/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "addch" set of curses functions */

#include <curses.h>
#include "fcursdef.h"

INT4 wmove_();

/*******************************************************************/

INT4 waddch_( wnum, ch )	/* the fortran routine is passing the */
INT4 *wnum;			/* integer representation of the character */
INT4 *ch;
{
	chtype tmpch = *ch;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return waddch( win, tmpch );
}

/**************************************************************/

/* as in C, this just calls 'waddch' with "stdscr" as the window */

INT4 addch_( ch )
INT4 *ch;
{
	return waddch_( (INT4 *) &stdscr, ch );
}

/***************************************************************/

/* combine the "wmove" and "waddch" functions */

INT4 mvwaddch_( wnum, y, x, ch )
INT4 *wnum;
INT4 *y;
INT4 *x;
INT4 *ch;
{
	if ( wmove_( wnum, y, x ) != ERR )
		return waddch_( wnum, ch );
	else
		return ERR;
}

/***************************************************************/

/* combine the "move" and "waddch" functions */

INT4 mvaddch_( y, x, ch )
INT4 *y;
INT4 *x;
INT4 *ch;
{
	if ( wmove_( (INT4 *) &stdscr, y, x ) != ERR )
		return waddch_( (INT4 *) &stdscr, ch );
	else
		return ERR;
}
