/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "attroff" and "attron" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*********************************************************/

INT4 wattroff_( wnum, attrs )
INT4 *wnum;
INT4 *attrs;
{
	WINDOW *win;
	chtype attmp;
	
	attmp = *attrs;	/* make sure to pass the correct */
		 	/* types to the curses routines */

	win = (WINDOW *) *wnum;

	return wattroff( win, attmp );
}

/**************************************************************/

INT4 attroff_( attrs )
INT4 *attrs;
{
	chtype attmp = *attrs;

	return attroff( attmp );
}

/*********************************************************/

INT4 wattron_( wnum, attrs )
INT4 *wnum;
INT4 *attrs;
{
	WINDOW *win;
	chtype attmp;
	
	attmp = *attrs;	/* make sure to pass the correct */
		 	/* types to the curses routines */

	win = (WINDOW *) *wnum;

	return wattron( win, attmp );
}

/**************************************************************/

INT4 attron_( attrs )
INT4 *attrs;
{
	chtype attmp = *attrs;

	return attron( attmp );
}

/*********************************************************/

INT4 wattrset_( wnum, attrs )
INT4 *wnum;
INT4 *attrs;
{
	WINDOW *win;
	chtype attmp;
	
	attmp = *attrs;	/* make sure to pass the correct */
		 	/* types to the curses routines */

	win = (WINDOW *) *wnum;

	return wattrset( win, attmp );
}

/**************************************************************/

INT4 attrset_( attrs )
INT4 *attrs;
{
	chtype attmp = *attrs;

	return attrset( attmp );
}

/*********************************************************/

INT4 wstandend_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wstandend( win );
}

/**************************************************************/

INT4 standend_()
{
	return standend();
}

/*********************************************************/

INT4 wstandout_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wstandout( win );
}

/**************************************************************/

INT4 standout_()
{
	return standout();
}
