/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "bkgd" set of curses functions */

#include <curses.h>
#include "fcursdef.h"

/*******************************************************************/

INT4 wbkgdset_( wnum, ch )	/* the fortran routine is passing the */
INT4 *wnum;			/* integer representation of the character */
INT4 *ch;			/* and attributes */
{
	WINDOW *win;
	chtype tmpch = *ch;

	win = (WINDOW *) *wnum;

	wbkgdset( win, tmpch );
	return OK;
}

/**************************************************************/

/* as in C, this just calls 'wbkgdset' with "stdscr" as the window */

INT4 bkgdset_( ch )
INT4 *ch;
{
	wbkgdset_( (INT4 *) &stdscr, ch );
	return OK;
}

/*******************************************************************/

INT4 wbkgd_( wnum, ch )	/* the fortran routine is passing the */
INT4 *wnum;			/* integer representation of the character */
INT4 *ch;			/* and attributes */
{
	WINDOW *win;
	chtype tmpch = *ch;

	win = (WINDOW *) *wnum;

	return wbkgd( win, tmpch );
}

/**************************************************************/

/* as in C, this just calls 'wbkgd' with "stdscr" as the window */

INT4 bkgd_( ch )
INT4 *ch;
{
	return wbkgd_( (INT4 *) &stdscr, ch );
}



/*******************************************************************/


/* The following two return the current background of a window */
/*   (these are not part of curses, but are needed in F-curses because */
/*	there is no direct access to a window structure ) */


INT4 wgetbkgd_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return win->_bkgd;
}

/**************************************************************/

INT4 getbkgd_()
{
	return stdscr->_bkgd;	
}
