/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "border" set of curses functions */

#include <curses.h>
#include "fcursdef.h"

/*******************************************************************/

INT4 wborder_( wnum, ls, rs, ts, bs, tl, tr, bl, br )
INT4 *wnum;
INT4 *ls;
INT4 *rs;
INT4 *ts;
INT4 *bs;
INT4 *tl;
INT4 *tr;
INT4 *bl;
INT4 *br;
{
	chtype tmpls = *ls;	/* convert from Fortran INT4s to */
	chtype tmprs = *rs;	/* "chtype" */
	chtype tmpts = *ts;
	chtype tmpbs = *bs;
	chtype tmptl = *tl;
	chtype tmptr = *tr;
	chtype tmpbl = *bl;
	chtype tmpbr = *br;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wborder( win, tmpls, tmprs, tmpts, tmpbs,
			tmptl, tmptr, tmpbl, tmpbr );
}

/**************************************************************/

INT4 border_( ls, rs, ts, bs, tl, tr, bl, br )
INT4 *ls;
INT4 *rs;
INT4 *ts;
INT4 *bs;
INT4 *tl;
INT4 *tr;
INT4 *bl;
INT4 *br;
{
	return wborder_( (INT4 *) &stdscr, ls, rs, ts, bs, tl, tr, bl, br );
}

/*******************************************************************/

INT4 box_( wnum, verch, horch )
INT4 *wnum;
INT4 *verch;
INT4 *horch;
{
	chtype tmpv = *verch;	/* convert from Fortran INT4s to */
	chtype tmph = *horch;	/* "chtype" */

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return box( win, tmpv, tmph );
}

/*******************************************************************/

INT4 whline_( wnum, ch, n )
INT4 *wnum;
INT4 *ch;
INT4 *n;
{
	chtype tmpch = *ch;	/* convert from Fortran INT4s to */
	int ntmp = *n;		/* "chtype" */

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return whline( win, tmpch, ntmp );
}

/**************************************************************/

INT4 hline_( ch, n )
INT4 *ch;
INT4 *n;
{
	return whline_( (INT4 *) &stdscr, ch, n );
}

/*******************************************************************/

INT4 wvline_( wnum, ch, n )
INT4 *wnum;
INT4 *ch;
INT4 *n;
{
	chtype tmpch = *ch;	/* convert from Fortran INT4s to */
	int ntmp = *n;		/* "chtype" */

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wvline( win, tmpch, ntmp );
}

/**************************************************************/

INT4 vline_( ch, n )
INT4 *ch;
INT4 *n;
{
	return wvline_( (INT4 *) &stdscr, ch, n );
}
