/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* mapping of the "color" set of curses routines */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************************/

/* start_color sets the maximum number of color pairs. */

/* implemented in combination with a fortran routine, use the temporary */
/* name "start_colc_" here */

INT4 start_colc_()
{
	return start_color();
}

/*************************************************************************/

INT4 init_pair_( pair, f, b )
INT4 *pair;
INT4 *f;
INT4 *b;
{
	short tpair = *pair;
	short tf = *f;
	short tb = *b;

	return init_pair( tpair, tf, tb );
}

/*************************************************************************/

INT4 init_color_( color, r, g, b )
INT4 *color;
INT4 *r;
INT4 *g;
INT4 *b;
{
	short tmpc = *color;
	short tmpr = *r;
	short tmpg = *g;
	short tmpb = *b;

	return init_color( tmpc, tmpr, tmpg, tmpb );
}

/*************************************************************************/

INT4 has_colors_()
{
	extern INT4 ftrue, ffalse;

	if ( has_colors() )
		return ftrue;
	else
		return ffalse;
}

/*************************************************************************/

INT4 can_change_color_()
{
	extern INT4 ftrue, ffalse;

	if ( can_change_color() )
		return ftrue;
	else
		return ffalse;
}

/*************************************************************************/

INT4 color_content_( color, r, g, b )
INT4 *color;
INT4 *r;
INT4 *g;
INT4 *b;
{
	int retval;

	short tmpc = (short) *color; 
	short *tmpr = (short *) r; 
	short *tmpg = (short *) g; 
	short *tmpb = (short *) b;

	retval = color_content( tmpc, tmpr, tmpg, tmpb );

	r = (INT4 *) tmpr;
	g = (INT4 *) tmpg;
	b = (INT4 *) tmpb;

	return retval;
}

/*************************************************************************/

INT4 pair_content_( pair, f, b )
INT4 *pair;
INT4 *f;
INT4 *b;
{
	int retval;

	short tmpp = (short) *pair; 
	short *tmpf = (short *) f; 
	short *tmpb = (short *) b; 

	retval = pair_content( tmpp, tmpf, tmpb );

	f = (INT4 *) tmpf;
	b = (INT4 *) tmpb;

	return retval;
}

/*************************************************************************/

INT4 clr_pair_( pair )
INT4 *pair;
{
	int tmp = *pair;

	return ( COLOR_PAIR(tmp) );
}

/*************************************************************************/

INT4 pair_nmbr_( attrs )
INT4 *attrs;
{
	chtype tmp = *attrs;

	return ( PAIR_NUMBER(tmp) );
}
