/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "getch" functions */
/* return the integer value of the character that is typed */
/*  -- on the FORTRAN side, use the "char" function for logical tests */
/*     and character assignments */

#include <curses.h>
#include "fcursdef.h"

INT4 wmove_();

/**************************************************************/

INT4 wgetch_( wnum )
INT4 *wnum;
{
	WINDOW *win;
#if defined(DOS)  || defined (OS2)
	int tmpval;
#endif

	win = (WINDOW *) *wnum;

#if defined(DOS)  || defined (OS2)
	tmpval = wgetch( win );

	if( tmpval == PADSLASH )
		tmpval = '/';
	else if( tmpval == PADENTER )
		tmpval = '\r';
	else if( tmpval == PADSTAR )
		tmpval = '*';
	else if( tmpval == PADMINUS )
		tmpval = '-';
	else if( tmpval == PADPLUS )
		tmpval = '+';

	return tmpval;
#else
	return wgetch( win );
#endif
}

/**************************************************************/

INT4 sgetch_()
{
	return wgetch_( (INT4 *) &stdscr );
}

/**************************************************************/

INT4 mvwgetch_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	if ( wmove_( wnum, y, x ) != ERR )
		return wgetch_( wnum );
	else
		return ERR;
}

/**************************************************************/

INT4 mvgetch_( y, x )
INT4 *y;
INT4 *x;
{
	if ( wmove_( (INT4 *) &stdscr, y, x ) != ERR )
		return wgetch_( (INT4 *) &stdscr );
	else
		return ERR;
}

/**************************************************************/

INT4 ungetc_( ch )
INT4 *ch;
{
	int tmpch;
	
	tmpch = *ch;	/* make sure to pass the correct type */

	return ungetch( tmpch );
}
