/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "getstr" set of functions */

/* use the "wgetnstr" routine in all the calls to ensure that the */
/* Fortran string is not overflowed */

#include <curses.h>
#include "fcursdef.h"

INT4 wmove_();

/**************************************************************/

INT4 twgetstr_( wnum, str, len )
INT4 *wnum;
char *str;
INT4 *len;
{
	int ntmp = *len;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wgetnstr( win, str, ntmp );
}

/**************************************************************/

INT4 tgetstr_( str, len )
char *str;
INT4 *len;
{
	int ntmp = *len;

	return wgetnstr( stdscr, str, ntmp );
}

/**************************************************************/

INT4 tmvwgetstr_( wnum, y, x, str, len )
INT4 *wnum;
INT4 *y;
INT4 *x;
char *str;
INT4 *len;
{
	if ( wmove_( wnum, y, x ) != ERR )
		return twgetstr_( wnum, str, len );
	else
		return ERR;
}

/**************************************************************/

INT4 tmvgetstr_( y, x, str, len )
INT4 *y;
INT4 *x;
char *str;
INT4 *len;
{
	if ( wmove_( (INT4 *) &stdscr, y, x ) != ERR )
		return twgetstr_( (INT4 *) &stdscr, str, len );
	else
		return ERR;
}

/**************************************************************/

INT4 twgetnstr_( wnum, str, len, n )
INT4 *wnum;
char *str;
INT4 *len;
INT4 *n;
{
	int ntmp = *n;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( ntmp > *len || ntmp < 1 )
		ntmp = *len;

	return wgetnstr( win, str, ntmp );
}
