/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "inch" functions */

/* return the integer value of the character and attributes at the  */
/* position of the curses on the screen */

/* use the IAND intrinsic to extract specific information on the Fortran side */
	/*  IAND( returnval, A_CHARTEXT ) to extract character (int*4) */
	/*  IAND( returnval, A_ATTRIBUTES) to extract attributes (int*4) */
	/*  IAND( returnval, A_COLOR ) to extract color pair value (int*4) */

#include <curses.h>
#include "fcursdef.h"

INT4 wmove_();

/**************************************************************/

INT4 winch_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return winch( win );
}

/**************************************************************/

INT4 inch_()
{
	return inch();
}

/**************************************************************/

INT4 mvwinch_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( wmove_( wnum, y, x ) != ERR )
		return winch( win );
	else
		return ERR;
}

/**************************************************************/

INT4 mvinch_( y, x )
INT4 *y;
INT4 *x;
{
	if ( wmove_( (INT4 *) &stdscr, y, x ) != ERR )
		return inch();
	else
		return ERR;
}
