/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "initscr" set of functions */

/* could not include the "SCREEN" related set of functions that allow */
/* multiple input/output screens to be contolled by curses because Fortran */
/* cannot correctly set/pass the file pointers for the different screens */
/* (sigh) */


#include <curses.h>
#include "fcursdef.h"

INT4 ftrue, ffalse;  /* these will store the FORTRAN values for */
			/* .TRUE. and .FALSE. */

/*********************************************************/

#include <signal.h>

INT4 inittmp_(ttmp, ftmp ) /* using a fortran routine called "initcurs", but */
INT4 *ttmp;			/* still need to call the C routine to enable curses */
INT4 *ftmp;
{
	void gracefulend();

	ftrue =  *ttmp;
	ffalse = *ftmp;

	signal(SIGINT, gracefulend);	/* call the routine gracefulend when
					 * the interrupt key is pressed. This
					 * will execute endwin() and exit so
					 * that the terminal isn't left in a
					 * funny state */

	return (INT4) initscr();
}

/*********************************************************/

INT4 endwin_()
{
	return endwin();
}

/*********************************************************/

INT4 isendwin_()
{
	if ( isendwin() )
		return ftrue;
	else
		return ffalse;
}
