/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "inopts" set of functions */

#include <curses.h>
#include "fcursdef.h"

/****************************************************************/

INT4 cbreak_()
{
	return cbreak();
}

/****************************************************************/

INT4 nocbreak_()
{
	return nocbreak();
}

/****************************************************************/

#ifdef ECHO
#undef ECHO
#endif

INT4 echo_()
{
	return echo();
}

/****************************************************************/

INT4 noecho_()
{
	return noecho();
}

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 halfdelay_( tenths )
INT4 *tenths;
{
	int tmptenths = *tenths;

	return halfdelay( tmptenths );
}
#endif

/****************************************************************/

INT4 intrflush_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return intrflush( win, TRUE );
	else
		return intrflush( win, FALSE );
}

/****************************************************************/

INT4 keypad_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return keypad( win, TRUE );
	else
		return keypad( win, FALSE );
}

/****************************************************************/

INT4 meta_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return meta( win, TRUE );
	else
		return meta( win, FALSE );
}

/****************************************************************/

INT4 nodelay_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return nodelay( win, TRUE );
	else
		return nodelay( win, FALSE );
}

/****************************************************************/

INT4 notimeout_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return notimeout( win, TRUE );
	else
		return notimeout( win, FALSE );
}

/****************************************************************/

INT4 raw_()
{
	return raw();
}

/****************************************************************/

INT4 noraw_()
{
	return noraw();
}

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 noqiflush_()
{
	noqiflush();
	return OK;
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 qiflush_()
{
	qiflush();
	return OK;
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 timeout_( delay )
INT4 *delay;
{
	int tmpdelay = *delay;

	timeout( tmpdelay );
	return OK;
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 wtimeout_( wnum, delay )
INT4 *wnum;
INT4 *delay;
{
	int tmpdelay = *delay;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	wtimeout( win, tmpdelay );
	return OK;
}
#endif

/****************************************************************/

INT4 typeahead_( fd )
INT4 *fd;
{
	int fdtmp = *fd;

	if( fdtmp == -1 )
		return typeahead( fdtmp );
	else
		return typeahead( 0 );
}
