/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "kernel" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 def_prog_mode_()
{
	return def_prog_mode();
}

/*************************************************************/

INT4 def_shell_mode_()
{
	return def_shell_mode();
}

/*************************************************************/

INT4 reset_prog_mode_()
{
	return reset_prog_mode();
}

/*************************************************************/

INT4 reset_shell_mode_()
{
	return reset_shell_mode();
}

/*************************************************************/

INT4 resetty_()
{
	return resetty();
}

/*************************************************************/

INT4 savetty_()
{
	return savetty();
}

/*************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 getsyx_( y, x )
INT4 *y;
INT4 *x;
{
	int tmpy = *y;
	int tmpx = *x;

	getsyx( tmpy, tmpx);

	*y = tmpy;
	*x = tmpx;

	return OK;
}
#endif

/*************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 setsyx_( y, x)
INT4 *y;
INT4 *x;
{
	int tmpy = *y;
	int tmpx = *x;

	return setsyx( tmpy, tmpx);

}
#endif

/****************************************/

/*** for now, not supporting the ripoffline function ***/

/****************************************/

/*************************************************************/

/* set the visibility of the cursor */

INT4 curs_set_( visibility )
INT4 *visibility;
{
	int vtmp = *visibility;

	return curs_set( vtmp );

}

/*************************************************************/

/* sleep for the specified number of milliseconds */

#ifdef BAD_NAPMS

#ifdef BSD

#include <sys/time.h>

#else

#include <sys/types.h>
#include <sys/times.h>
/* #define HZ	100*/
#include <sys/param.h>		/* HZ should be defined in here */
/*#include <limits.h>*/		/* another alternative */
/*#define HZ	CLK_TCK*/

#endif

#endif /* BAD_NAPMS */

INT4 napms_( ms )
INT4 *ms;
{
	int pms = *ms;	/* hopefully, pms won't last too long ! */

#ifdef BAD_NAPMS
#ifdef BSD
	struct timeval tv; /* i think this will work... */
	struct timezone tz;
	double t1;
	gettimeofday( &tv, &tz );
	t1 = tv.tv_sec + ( tv.tv_usec / 1000. );
	do
		gettimeofday( &tv, &tz );
	while (( tv.tv_sec + (tv.tv_usec / 1000. ) - t1 ) < pms );
#else /* BSD */
	struct tms t;
	long t1;
	t1 = times(&t);
	while ((times(&t) - t1)*1000 < HZ*pms )
		;
#endif /* BSD */
	return OK;
#else /* BAD_NAPMS */
	return napms( pms );
#endif /* BAD_NAPMS */
}
