/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "outopts" set of functions */

#include <curses.h>
#include "fcursdef.h"

/****************************************************************/

INT4 clearok_( wnum, bf )	/* bf if FORTRAN .TRUE. or .FALSE. */
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return clearok( win, TRUE );
	else
		return clearok( win, FALSE );
}

/****************************************************************/

INT4 idlok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return idlok( win, TRUE );
	else
		return idlok( win, FALSE );
}

/****************************************************************/

INT4 idcok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		idcok( win, TRUE );
	else
		idcok( win, FALSE );
	return OK;
}

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 immedok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		immedok( win, TRUE );
	else
		immedok( win, FALSE );
	return OK;
}
#endif

/****************************************************************/

INT4 leaveok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return leaveok( win, TRUE );
	else
		return leaveok( win, FALSE );
}

/****************************************************************/

INT4 wsetscrreg_( wnum, top, bot )
INT4 *wnum;
INT4 *top;
INT4 *bot;
{
	WINDOW *win;
	int toptmp, bottmp;
	
	toptmp = *top;
	bottmp = *bot;

	win = (WINDOW *) *wnum;

	return wsetscrreg( win, toptmp, bottmp);
}

/****************************************************************/

INT4 setscrreg_( top, bot )
INT4 *top;
INT4 *bot;
{
	return wsetscrreg_( (INT4 *) &stdscr, top, bot );
}

/****************************************************************/

INT4 scrollok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return scrollok( win, TRUE );
	else
		return scrollok( win, FALSE );
}

/****************************************************************/

INT4 nl_()
{
	return nl();
}

/****************************************************************/

INT4 nonl_()
{
	return nonl();
}
