/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "overlay" set of functions */

#include <curses.h>
#include "fcursdef.h"

/****************************************************************/

INT4 overlay_( srcwin, dstwin )
INT4 *srcwin;
INT4 *dstwin;
{
	WINDOW *win1, *win2;

	win1 = (WINDOW *) *srcwin;
	win2 = (WINDOW *) *dstwin;

	return overlay( win1, win2 );
}

/****************************************************************/

INT4 overwrite_( srcwin, dstwin )
INT4 *srcwin;
INT4 *dstwin;
{
	WINDOW *win1, *win2;

	win1 = (WINDOW *) *srcwin;
	win2 = (WINDOW *) *dstwin;

	return overwrite( win1, win2 );
}

/****************************************************************/

INT4 copywin_( srcwin, dstwin, sminrow, smincol, dminrow, dmincol,
			dmaxrow, dmaxcol, overlay )
INT4 *srcwin;
INT4 *dstwin;
INT4 *sminrow;
INT4 *smincol;
INT4 *dminrow;
INT4 *dmincol;
INT4 *dmaxrow;
INT4 *dmaxcol;
INT4 *overlay;
{
	extern INT4 ftrue;

	int snrow = *sminrow;
	int sncol = *smincol;
	int dnrow = *dminrow;
	int dncol = *dmincol;
	int dxrow = *dmaxrow;
	int dxcol = *dmaxcol;

	WINDOW *win1, *win2;

	win1 = (WINDOW *) *srcwin;
	win2 = (WINDOW *) *dstwin;

	if ( *overlay == ftrue )
		return copywin( win1, win2, snrow, sncol,
			dnrow, dncol, dxrow, dxcol, TRUE );
	else
		return copywin( win1, win2, snrow, sncol,
			dnrow, dncol, dxrow, dxcol, FALSE );
}
