/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "pad" set of functions */

#include <curses.h>
#include "fcursdef.h"

/****************************************************************/

INT4 newpad_( nlines , ncols )
INT4 *nlines;
INT4 *ncols;
{
	int nltmp = *nlines;
	int nctmp = *ncols;

	return (INT4) newpad( nltmp, nctmp );
}

/****************************************************************/

INT4 subpad_( orig, nlines , ncols, begin_y, begin_x )
INT4 *orig;
INT4 *nlines;
INT4 *ncols;
INT4 *begin_y;
INT4 *begin_x;
{
	WINDOW *otmp;

	int yt = *begin_y;	/* make sure to pass the correct */
	int xt = *begin_x;	/* types to the curses routines */
	int nltmp = *nlines;
	int nctmp = *ncols;

	otmp = (WINDOW *) *orig;

	return (INT4) subpad( otmp, nltmp, nctmp, yt, xt );
}

/****************************************************************/

INT4 prefresh_( pad, pminrow, pmincol, sminrow, smincol, smaxrow, smaxcol )
INT4 *pad;
INT4 *pminrow;
INT4 *pmincol;
INT4 *sminrow;
INT4 *smincol;
INT4 *smaxrow;
INT4 *smaxcol;
{
	int pnrow = *pminrow;
	int pncol = *pmincol;
	int snrow = *sminrow;
	int sncol = *smincol;
	int sxrow = *smaxrow;
	int sxcol = *smaxcol;

	WINDOW *win;

	win = (WINDOW *) *pad;

	return prefresh( win, pnrow, pncol, snrow, sncol, sxrow, sxcol);
}

/****************************************************************/

INT4 pnoutrefresh_( pad, pminrow, pmincol, sminrow,
			smincol, smaxrow, smaxcol )
INT4 *pad;
INT4 *pminrow;
INT4 *pmincol;
INT4 *sminrow;
INT4 *smincol;
INT4 *smaxrow;
INT4 *smaxcol;
{
	int pnrow = *pminrow;
	int pncol = *pmincol;
	int snrow = *sminrow;
	int sncol = *smincol;
	int sxrow = *smaxrow;
	int sxcol = *smaxcol;

	WINDOW *win;

	win = (WINDOW *) *pad;

	return pnoutrefresh( win, pnrow, pncol, snrow, sncol, sxrow, sxcol);
}

/*******************************************************************/

INT4 pechochar_( pad, ch )	/* the fortran routine is passing the */
INT4 *pad;			/* integer representation of the character */
INT4 *ch;
{
	chtype tmpch = *ch;

	WINDOW *win;

	win = (WINDOW *) *pad;

	return pechochar( win, tmpch );
}
