/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "printw" functions */
/* since fortran can't make use of the C format statments, only use */
/* these calls to pass strings followed by carriage returns */


#include <curses.h>
#include "fcursdef.h"

INT4 wmove_();

/*******************************************************************/

INT4 twprintw_( wnum, str, len )
INT4 *wnum;
char *str;
INT4 *len;
{
	int ntmp = *len;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	if( waddnstr( win, str, ntmp ) == ERR )
		return ERR;
	else
		return waddch( win, '\n' );
}

/**************************************************************/

INT4 tprintw_( str, len )
char *str;
INT4 *len;
{
	return twprintw_( (INT4 *) &stdscr, str, len );
}

/***************************************************************/

INT4 tmvwprintw_( wnum, y, x, str, len )
INT4 *wnum;
INT4 *y;
INT4 *x;
char *str;
INT4 *len;
{
	if ( wmove_( wnum, y, x ) != ERR )
		return twprintw_( wnum, str, len );
	else
		return ERR;
}

/***************************************************************/

INT4 tmvprintw_( y, x, str, len )
INT4 *y;
INT4 *x;
char *str;
INT4 *len;
{
	if ( wmove_( (INT4 *) &stdscr, y, x ) != ERR )
		return twprintw_( (INT4 *) &stdscr, str, len );
	else
		return ERR;
}
