/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "termattrs" set of functions */

#include <curses.h>
#include "fcursdef.h"

#include <string.h>

/*************************************************************/

INT4 baudrate_()
{
	return baudrate();
}

/*************************************************************/

INT4 erasechar_()
{
	return (INT4) erasechar();
}

/*************************************************************/

INT4 has_ic_()
{
	extern INT4 ftrue, ffalse;

	if ( has_ic() )
		return ftrue;
	else
		return ffalse;
}

/*************************************************************/

INT4 has_il_()
{
	extern INT4 ftrue, ffalse;

	if ( has_il() )
		return ftrue;
	else
		return ffalse;
}

/*************************************************************/

INT4 killchar_()
{
	return (INT4) killchar();
}

/*************************************************************/

/* this gets the long terminal name from "longname", places it in */
/* "str", and passes it back to a fortran routine called "longname" that */
/* is called by the fortran application */

INT4 longtmp_( str, len )
char *str;
INT4 *len;
{
	int end, i;
	char tmpstr[128];

	if( strcpy(tmpstr,longname()) == NULL )
		return ERR;
	end = strlen(tmpstr);

	end = (end<*len?end:*len);

	for (i = 0; i < *len; i++) {
		if( i < end )
			str[i] = tmpstr[i];
		else
			str[i] = ' ';
	}

	return OK;
	
}

/*************************************************************/

INT4 termattrs_()
{
	return (INT4) termattrs();
}

/*************************************************************/

/* this gets the short terminal name from "termname", places it in */
/* "str", and passes it back to a fortran routine called "termname" that */
/* is called by the fortran application */

INT4 termtmp_( str, len )
char *str;
INT4 *len;
{
	int end, i;
	char tmpstr[14];

	if( strcpy(tmpstr,termname()) == NULL )
		return ERR;
	end = strlen(tmpstr);

	end = (end<*len?end:*len);

	for (i = 0; i < *len; i++) {
		if( i < end )
			str[i] = tmpstr[i];
		else
			str[i] = ' ';
	}

	return OK;
	
}
