/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "touch" set of functions */

#include <curses.h>
#include "fcursdef.h"

/*************************************************************/

INT4 touchwin_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return touchwin( win );
}

/*************************************************************/

INT4 touchline_( wnum, start, count )
INT4 *wnum;
INT4 *start;
INT4 *count;
{
	int tmpstart = *start;
	int tmpcount = *count;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return touchline( win, tmpstart, tmpcount );
}

/*************************************************************/

INT4 untouchwin_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return untouchwin( win );
}

/*************************************************************/

INT4 wtouchln_( wnum, y, n , changed )
INT4 *wnum;
INT4 *y;
INT4 *n;
INT4 *changed;
{
	int tmpy = *y;
	int tmpn = *n;
	int tmpchange = *changed;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return wtouchln( win, tmpy, tmpn, tmpchange );
}

/*************************************************************/

INT4 is_linetouched_( wnum, line )
INT4 *wnum;
INT4 *line;
{
	extern INT4 ftrue, ffalse;
	int tmpline = *line;

	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( is_linetouched( win, tmpline ) )
		return ftrue;
	else
		return ffalse;
}

/*************************************************************/

INT4 is_wintouched_( wnum )
INT4 *wnum;
{
	extern INT4 ftrue, ffalse;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( is_wintouched( win ) )
		return ftrue;
	else
		return ffalse;
}
