/*  Copyright (C) 1993 Wade R. Schauer  */
/*  All Rights Reserved                 */
/*  ----------------------------------  */
/**/
/* fortran call of the curses "window" create, delete, */
/* and move set of functions */

#include <curses.h>
#include "fcursdef.h"

/****************************************************************/

/* create a new window, however, rather than returning a pointer to the */
/* successfully opened window, return an integer that will be used for */
/* future reference to the window */

INT4 newwin_( nlines , ncols, begin_y, begin_x )
INT4 *nlines;
INT4 *ncols;
INT4 *begin_y;
INT4 *begin_x;
{
	int nltmp, nctmp, yt, xt;
	
	yt = *begin_y;		/* make sure to pass the correct */
	xt = *begin_x;		/* types to the curses routines */
	nltmp = *nlines;
	nctmp = *ncols;

	return (INT4) newwin( nltmp, nctmp, yt, xt );
}

/****************************************************************/

INT4 delwin_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	return (INT4) delwin( win );
}

/****************************************************************/

INT4 mvwin_( wnum, y, x )
INT4 *wnum;
INT4 *y;
INT4 *x;
{
	int yt = *y;	/* make sure to pass the correct */
	int xt = *x;	/* types to the curses routines */

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return mvwin( win, yt, xt );
}

/****************************************************************/

INT4 subwin_( orig, nlines , ncols, begin_y, begin_x )
INT4 *orig;
INT4 *nlines;
INT4 *ncols;
INT4 *begin_y;
INT4 *begin_x;
{
	int yt = *begin_y;		/* make sure to pass the correct */
	int xt = *begin_x;		/* types to the curses routines */
	int nltmp = *nlines;
	int nctmp = *ncols;

	WINDOW *otmp;

	otmp = (WINDOW *) *orig;

	return (INT4 ) subwin( otmp, nltmp, nctmp, yt, xt );
}

/****************************************************************/

INT4 derwin_( orig, nlines , ncols, begin_y, begin_x )
INT4 *orig;
INT4 *nlines;
INT4 *ncols;
INT4 *begin_y;
INT4 *begin_x;
{
	int yt = *begin_y;		/* make sure to pass the correct */
	int xt = *begin_x;		/* types to the curses routines */
	int nltmp = *nlines;
	int nctmp = *ncols;

	WINDOW *otmp;

	otmp = (WINDOW *) *orig;

	return (INT4) derwin( otmp, nltmp, nctmp, yt, xt );
}

/****************************************************************/

INT4 mvderwin_( wnum, par_y, par_x )
INT4 *wnum;
INT4 *par_y;
INT4 *par_x;
{
	int yt = *par_y;		/* make sure to pass the correct */
	int xt = *par_x;		/* types to the curses routines */

	WINDOW *win;

	win = (WINDOW *) *wnum;

	return mvderwin( win, yt, xt );
}

/****************************************************************/

INT4 dupwin_( orig )
INT4 *orig;
{
	WINDOW *otmp;

	otmp = (WINDOW *) *orig;

	return (INT4 ) dupwin( otmp );
}

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 wsyncup_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	wsyncup( win );
	return OK;
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 syncok_( wnum, bf )
INT4 *wnum;
INT4 *bf;
{
	extern INT4 ftrue;
	WINDOW *win;

	win = (WINDOW *) *wnum;

	if ( *bf == ftrue )
		return syncok( win, TRUE );
	else
		return syncok( win, FALSE );
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 wcursyncup_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	wcursyncup( win );
	return OK;
}
#endif

/****************************************************************/

#if !defined(DOS) && !defined(OS2)
INT4 wsyncdown_( wnum )
INT4 *wnum;
{
	WINDOW *win;

	win = (WINDOW *) *wnum;

	wsyncdown( win );
	return OK;
}
#endif
