
************************************************************

	subroutine arithmetic( ACTTYPE )

*	this routine is called for basic arithmetic (multiply, divide,
*	plus, minus, equal) operations.
	
	implicit none

	integer ACTTYPE

	include 'calcstat.fh'	

	include 'register.fh'

	integer*4 retval, i, j

	real*8  fieldval, fieldval_i
	integer*4 displayval

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	equivalence ( cmpval, splitcmp(1) )

*  if the STO or the RCL key has been pressed, then PLUS, MINUS, MULTIPLY,
*  or DIVIDE actions can be performed on stored values with the value
*  on the display (x).

	if( memopt .eq. 2 .or. rclopt .eq. 2 ) then
	  if( (ACTTYPE .eq. PLUSACT .or. ACTTYPE .eq. MINUSACT .or.
&	      ACTTYPE .eq. DIVACT .or. ACTTYPE .eq. MULTACT .or.
&	      ACTTYPE .eq. MODACT) .and. mempoint .eq. 0 ) then
		memact = ACTTYPE
		return
	  endif
	endif

*  if in RPN mode, jump to the end of the routine for a much simpler
*  set of operations

	if( rpnmode ) go to 1500


*  if no other action keys have been pressed since the number was first
*  entered, then this current action causes the calculator to operate
*  on the currently displayed number using the previous action and
*  number stored in register 1.

	if( .not. action ) then

		action = .true.
		numinit = .true.
		
		lastx   = screenval
		lastx_i = screenval_i
		fieldval   = screenval
		fieldval_i = screenval_i

		call popact( fieldval, fieldval_i, ACTTYPE )

		if( displayval( fieldval, fieldval_i ) .eq. -1 ) then
		  return
		endif

	endif

*  if the action is a closing parenthesis, then drop the registers 1 level and
*  complete the calculations of the appropriate parenthesis set.

	if( ACTTYPE .eq. CLOSEACT) then
	  if( reglev .gt. 1) then

		do i = 2, reglev
		   do j = 1,2
		      regval(i-1,j)   = regval(i,j)
		      regvalmd(i-1,j) = regvalmd(i,j)
		      regvalpw(i-1,j) = regvalpw(i,j)
		   end do
		   regact(i-1) = regact(i)
		   regactmd(i-1) = regactmd(i)
		   regactpw(i-1) = regactpw(i)
		end do
		reglev = reglev - 1

	  endif

	  action = .false.

*    the EQUAL action adds closing parenthesis to all open parenthesis sets
*	and displays the final value of the calculation

	elseif( ACTTYPE .eq. EQUALACT) then

	  do while ( reglev .gt. 1)

		do i = 2, reglev
		   do j = 1,2
		      regval(i-1,j) = regval(i,j)
		      regvalmd(i-1,j) = regvalmd(i,j)
		      regvalpw(i-1,j) = regvalpw(i,j)
		   end do
		   regact(i-1) = regact(i)
		   regactmd(i-1) = regactmd(i)
		   regactpw(i-1) = regactpw(i)
		end do
		reglev = reglev - 1
	  	
		call popact( fieldval, fieldval_i, ACTTYPE )

		if( displayval( fieldval, fieldval_i ) .eq. -1 ) then
		  return
		endif

	  end do

	  action = .false.
	  regact(1) = 0
	  regval(1,1) = 0.
	  regval(1,2) = 0.
	  regactmd(1) = 0
	  regactpw(1) = 0

	else

		regact(1) = ACTTYPE

	endif

	return

*--------------------------
*  RPN stuff  (overall, much simpler to deal with)

 1500	numinit = .true.

	if( ACTTYPE .eq. EQUALACT ) then
	  action = .false.
	  do i = MAXREGS, 2, -1
	  	regval(i,1) = regval(i-1,1)
	  	regval(i,2) = regval(i-1,2)
	  end do
	  regval(1,1) = screenval
	  regval(1,2) = screenval_i
	  fieldval = screenval
	  fieldval_i = screenval_i
	  retval = displayval( fieldval, fieldval_i )
	elseif( ACTTYPE .eq. CLOSEACT ) then
	  action = .true.
	  fieldval   = screenval
	  fieldval_i = screenval_i
	  screenval   = regval(1,1)
	  screenval_i = regval(1,2)
	  do i = 1, MAXREGS-1
	  	regval(i,1) = regval(i+1,1)
	  	regval(i,2) = regval(i+1,2)
	  end do
	  regval(MAXREGS,1) = fieldval
	  regval(MAXREGS,2) = fieldval_i
	  fieldval   = screenval
	  fieldval_i = screenval_i
	  retval = displayval(fieldval,fieldval_i)
	else
		lastx   = screenval
		lastx_i = screenval_i
		action = .true.
		cmpval  = dcmplx( screenval, screenval_i )
		cmpval2 = dcmplx( regval(1,1), regval(1,2) )
		if( ACTTYPE .eq. PLUSACT ) then
		  cmpval = cmpval2 + cmpval
		elseif( ACTTYPE .eq. MINUSACT ) then
		  cmpval = cmpval2 - cmpval
		elseif( ACTTYPE .eq. MULTACT ) then
		  cmpval = cmpval2 * cmpval
		elseif( ACTTYPE .eq. DIVACT .or. ACTTYPE .eq. MODACT ) then
		  if( splitcmp(1) .eq. 0. .and. splitcmp(2) .eq. 0. ) then
		    cmpval = 1.0d150
		  elseif( ACTTYPE .eq. DIVACT ) then
		    cmpval = cmpval2 / cmpval
		  else
		    if( compmode ) then
		      cmpval = 1.0d150
		      errstate = 2
		    else
		      cmpval = mod( regval(1,1), screenval )
		    endif
		  endif
		elseif( ACTTYPE .eq. POWRACT ) then
		  if( compmode ) then
		    if( screenval*log10(abs(regval(1,1))) .lt. 105 .and.
&		        screenval_i*log10(abs(regval(1,2))) .lt. 105 .and.
&		        screenval*log10(abs(regval(1,2))) .lt. 105 .and.
&		        screenval_i*log10(abs(regval(1,1))) .lt. 105 ) then
		      cmpval = cmpval2**cmpval
		    else
		      cmpval = 1.0d150
		    endif
		  else
		    if(regval(1,1) .gt. 0. .or. (regval(1,1) .lt. 0. .and.
&		    		screenval .eq. int(screenval)) ) then
		      if( screenval * log10(abs(regval(1,1))) .lt. 100 ) then
		        cmpval = regval(1,1)**screenval
		      else
		        cmpval = 1.0D150
		      endif
		    elseif( regval(1,1) .lt. 0. ) then
		      cmpval = 1.0D150
		    elseif( screenval .gt. 0. ) then
		      cmpval = 0.
		    else
		      cmpval = 1.0d150
		    endif
		  endif
		endif
		retval = displayval( splitcmp(1), splitcmp(2) )
		if( retval .ne. -1 ) then
		  do i = 1, MAXREGS-1
		  	regval(i,1) = regval(i+1,1)
		  	regval(i,2) = regval(i+1,2)
		  end do
		endif
	endif

	return

  	end
