
*****************************************************************
* wrs (8/1/92)

*  ch2double

*  convert a string to a real*8 number, string can be "any" length
*
*    input string is passed as argument, returned value passed as
*	a double precision real
*
*	Integer function returns -1 on error, 0 on success
*

	integer*4 function ch2double( str, value )

	implicit none

	character*(*) str
	real*8  value
	character*1   ch

	real*8 tmpval, powr, sign, psign, tmpdig

	logical  digit, expon, point, lsign, lpsign, exdigit

	integer ll, ic, blank, denlev

******************************

	ch2double = -1

	ll = len(str)

	if(ll .lt. 1) return

	tmpval  = 0.0
	powr    = 0.0
	sign    = 1.0
	psign   = 1.0
	blank   = 0
	denlev  = 0
	digit   = .false.
	exdigit = .false.
	expon   = .false.
	point   = .false.
	lsign   = .false.
	lpsign  = .false.

*       any "returns" in the loop signify an error, the value of CH2DOUBLE will
*	then be the -1 set above

	do ic = 1,ll

	   ch = str(ic:ic)

	   if(ch .ne. ' ' .and. ch .ne. char(0) ) then

*            allow blanks before and after number, but no blanks between
*            other valid characters

	     if(blank .eq. 2) return
	     blank = 1

*	     can have one sign value before the number and one before the
*	     exponent (optional)

	     if(ch .eq. '+' .or. ch .eq. '-') then

	       if(.not. lsign) then
	         if(digit .or. point) then
	           return
	         elseif(ch .eq. '+') then
	           sign = 1.0
	         else
	           sign = -1.0
	         endif
	         lsign = .true.
	       elseif(expon .and. (.not. lpsign)) then
	         if(exdigit) then
	           return
	         elseif(ch .eq. '+') then
	           psign = 1.0
	         else
	           psign = -1.0
	         endif
	         lpsign = .true.
	       else
	         return
	       endif

*	     "e" or "d" signifies an exponent is following

	     elseif(ch .eq. 'E' .or. ch .eq. 'e' .or. ch .eq. 'D' .or.
     .              ch .eq. 'd' ) then

	       if(digit .and. (.not. expon)) then
	         expon = .true.
*	         a positive sign value was implicit if we found an
*	         exponent
	         lsign = .true.
	       else
	         return
	       endif

*	     a decimal point is only allowed as part of the number, not
*	     the exponent.

	     elseif(ch .eq. '.') then    

	       if( point .or. expon) then
	         return
	       else
	         point = .true.
	       endif

*	     modify the number or the exponent value considering whether or
*            not a decimal point has been found

	     elseif( ichar(ch) .ge. 48 .and. ichar(ch) .le. 57 ) then

	       tmpdig = ichar(ch) - 48.

	       if(.not. expon) then
	         digit = .true.
	         if(point) then
	           denlev = denlev + 1
	           tmpval = tmpval + tmpdig/(10.0d0**denlev)
	         else
	           tmpval = tmpval*10.0 + tmpdig
	         endif
	       else
	         exdigit = .true.
	         powr = powr*10.0 + tmpdig
	       endif

*	     found some illegal character

	     else
	       return
	     endif

	   elseif(blank .eq. 1) then
	       blank = 2
	   endif

	end do

*	a string with all blanks is equal to zero

	if(blank .ne. 0) then
	  if(.not. digit) return
	  if(expon .and. (.not. exdigit)) return
	endif

********************************
*  combine the values that have been calculated

	value = sign*tmpval * (10.0d0**(psign*powr))

	ch2double = 0

********************************

	return

	end
