
************************************************************

	integer*4 function displayval( value, value_i )

* after a value is calculated, display it to the screen depending on
* the user's specified precision, the "size" of the value, and whether
* scientific or normal display methods are being used.
	
	implicit none
	
	real*8 value, value_i
	
	include '../../curses.fh'

	include 'calclate.fh'

	include 'calcstat.fh'

	include 'register.fh'

	integer exponval, exponval_i

	character tmpstr*25, fmat*10, addcommas*25, tmpstr2*25
	integer*4 firstchr, wjustify, retval, is, ll, lastchr, ic, i, iprec
	integer*4 itype, maxtype
	real*8    checkval

	displayval = -1

*	the Fortran log10 function is nice because it lets me determine
*	how big the number is.

	if( value .ne. 0. ) then
		exponval = log10(abs(value))
	else
		exponval = 0
	endif
	if( value_i .ne. 0. ) then
		exponval_i = log10(abs(value_i))
	else
		exponval_i = 0
	endif

*	exponents greater than 99 will cause error display and reinitialization
*	of the calculator.

	if( abs(exponval) .gt. 99 .or. abs(exponval_i) .gt. 99 ) then

		if( errstate .eq. 2 ) then
		  retval = wjustify( mainfield,'NO COMPLEX', 2, .FALSE., .TRUE.)
		elseif( errstate .eq. 3 ) then
		  retval = wjustify( mainfield,'ERR STATS', 2, .FALSE., .TRUE.)
		else
		  retval = wjustify( mainfield,'ERR', 2, .FALSE., .TRUE.)
		endif
		retval = wjustify( expfield,'      ', 2, .FALSE., .TRUE.)
		if(compmode) then
			retval = wjustify( mainfield_i,'     ', 2, .FALSE., .TRUE.)
			retval = wjustify( expfield_i,'      ', 2, .FALSE., .TRUE.)
		endif

		recording = 0
		if( playback .gt. 0 ) then
			playback  = 0
			rpnmode = holdmode
		endif

		numinit = .true.
		reglev = 1
		regact(1) = 0
		screenval = 0.
		screenval_i = 0.
		errstate = 0
		retval = beep()
		return

	endif

*	whenever a value is sent to the screen after calculation, also
*	store it in real*8 memory (screenval)

	screenval   = value
	screenval_i = value_i
	displayval = 0

*	display both real and imaginary numbers if in complex mode

	if( compmode ) then
	  maxtype = 2
	else
	  maxtype = 1
	endif

	do itype = 1, maxtype

	   if( itype .eq. 2 ) then
	     exponval = exponval_i
	     tmpval = value_i
	   else
	     tmpval = value
	   endif

*	   if using free precision, strip off trailing zero's

	   if( scinot .or. exponval .gt. 11 .or. exponval .lt. -10 .or.
&		(precision .lt. 0 .and. exponval .lt. -2) ) then

*		use scientific notation if specified or if the value
*		is too big or too small.

		if( exponval .lt. 0 ) exponval = exponval - 1

		tmpval = tmpval / ( 10.0D0**exponval )

		if( abs(tmpval) .lt. 1.0d0 .and. tmpval .ne. 0.) then
		  tmpval = tmpval*10.0D0
		  exponval = exponval - 1
		endif
		write( tmpstr, '(f16.11)' ) tmpval

  140		if( precision .lt. 0 .or. (.not. scinot)) then
			write( tmpstr, '(f16.11)' ) tmpval
			read(  tmpstr, '(f16.0)' ) checkval
			ll = lastchr( tmpstr )
			do while( tmpstr(ll:ll) .eq. '0')
				tmpstr(ll:ll) = ' '
				ll = ll - 1
			end do
		else
			if( precision .lt. 10 ) then
			  write( fmat, 150 ) precision
  150			  format( '(f16.',i1,')' )
			else
			  write( fmat, 160 ) precision
  160			  format( '(f16.',i2,')' )
			endif
			write( tmpstr, fmat ) tmpval
			read(  tmpstr, '(f16.0)' ) checkval
		endif
		if( abs(checkval) .gt. 9.999999999999d0 ) then
		  tmpval = tmpval/10.0D0
		  exponval = exponval + 1
		  go to 140
		endif

		if( tmpval .eq. 0. ) then
			ic = index(tmpstr,'.') - 1
			if(ic .le. 0) then
				tmpstr2 = '0' // tmpstr
				tmpstr = tmpstr2
			elseif( tmpstr(ic:ic) .ne. '0' ) then
				tmpstr(ic:ic) = '0'
			endif
		endif

		if( itype .eq. 1 ) then
		  retval = wjustify( mainfield, tmpstr, 2, .FALSE., .TRUE.)
		else
		  retval = wjustify( mainfield_i, tmpstr, 2, .FALSE., .TRUE.)
		endif

		if(exponval .lt. 0) then
			write( tmpstr, '(a,i2.2)' ) 'ee-',iabs(exponval)
		else
			write( tmpstr, '(a,i2.2)' ) 'ee+',iabs(exponval)
		endif
		if( itype .eq. 1 ) then
		  retval = wjustify( expfield, tmpstr, 2, .FALSE., .TRUE.)
		else
		  retval = wjustify( expfield_i, tmpstr, 2, .FALSE., .TRUE.)
		endif

	   else

		if( exponval .gt. 0 ) then
		  iprec = 11 - exponval
		  if( precision .ge. 0 ) then
		    iprec = min( precision, iprec )
		  endif
		else
		  iprec = 12
		  if( precision .ge. 0 ) then
		    iprec = min( precision, iprec )
		  endif
		endif

		if( iprec .lt. 10 ) then
		  write( fmat, 150 ) iprec
		else
		  write( fmat, 160 ) iprec
		endif
		write( tmpstr, fmat ) tmpval

		is = firstchr( tmpstr )
		tmpstr = tmpstr(is:)

		ll = lastchr( tmpstr )
		if( precision .lt. 0 ) then
			do while( tmpstr(ll:ll) .eq. '0')
				tmpstr(ll:ll) = ' '
				ll = ll - 1
			end do
		endif

		if( tmpval .eq. 0. ) then
			ic = index(tmpstr,'.') - 1
			if(ic .le. 0) then
				tmpstr2 = '0' // tmpstr
				tmpstr = tmpstr2
			elseif( tmpstr(ic:ic) .ne. '0' ) then
				tmpstr(ic:ic) = '0'
			endif
		endif
		if( commas ) then
			tmpstr = addcommas( tmpstr )
		endif
		if( itype .eq. 1 ) then
		  retval = wjustify( mainfield, tmpstr, 2, .FALSE., .TRUE.)
		  retval = wjustify( expfield, '       ', 2, .FALSE., .TRUE.)
		else
		  retval = wjustify( mainfield_i, tmpstr, 2, .FALSE., .TRUE.)
		  retval = wjustify( expfield_i, '       ', 2, .FALSE., .TRUE.)
		endif

	   endif

	end do

	return
	end
