
***************************************************************************

* fillwin - fill window with next paragraph from a file
*
*	returns 1 on success (or end of window), 0 if at end of file
*

*	integer function fillwin(f, win)
*	 integer f; integer win;
*	returns 0 on EOF, 1 otherwise
*	Reads data until a formfeed, puts data into window.  Several
*	control characters are allowed; their occurrence in the file
*	causes fillwin to modify attributes.  The valid characters are:
*		^B - bold
*		^F - flash
*		^N - normal
*		^R - reverse
*		^U - underline

	integer function fillwin(f, win)

	implicit none

	include '../../curses.fh'

	integer f, win

	integer ch
	integer y, x

	character  tmpstr*256
	integer  endstr, lastchr,i, retval
 
*	indent a few columns

	y = 0
	retval = wmove(win, y, 1)

*	read the contents of the file into the window until the last line
*	of the window or the file is reached.

	do while (.true.)

		read(f,'(A)', end=1000) tmpstr

		endstr = lastchr(tmpstr)

*		break on formfeed, add attributes to the text if certain
*		control characters are imbedded in the input file.

		do i = 1, endstr
			ch = ichar(tmpstr(i:i))

			if( ch .eq. KEY_FF ) go to 500

			if ( ch .eq. CTRL('b') ) then
				retval = wattron(win, A_BOLD)
			elseif ( ch .eq. CTRL('f') ) then
				retval = wattron(win, A_BLINK)
			elseif ( ch .eq. CTRL('n') ) then
				retval = wattrset(win, 0)
			elseif ( ch .eq. CTRL('r') ) then
				if( has_colors() .and. COLOR_PAIRS .gt. 0 ) then
				  retval = wattron(win, A_BOLD)
				endif
				retval = wattron(win, A_REVERSE)
			elseif ( ch .eq. CTRL('u') ) then
				retval = wattron(win, A_UNDERLINE)
			else
				if( ERR .eq. waddch(win, ch) ) then
					fillwin = 1
					return
				endif
			endif
		end do

		y = y + 1
		if( ERR .eq. wmove(win, y, 1) ) then
			fillwin = 1
			return
		endif
	end do
  500	fillwin = 1
	return
 1000	fillwin = 0
 	return
 	end
