
************************************************************

	subroutine number( ch )

* display a user's numerical entry to the calculator display,
* allowing the user to backspace to correct mistakes.  Different things
* can occur depending on what keys have been pressed.
	
	implicit none

	include '../../curses.fh'
	
	character*1 ch

	include 'calclate.fh'	

	include 'calcstat.fh'

	include 'register.fh'

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	character tmpstr*25, stripcommas*25, addcommas*25, tmpstr2*25
	integer*4 firstchr, wjustify, retval, is, ic, ie, lastchr, imr, i
	integer*4 displayval, mfield, efield

	equivalence ( cmpval, splitcmp(1) )

	if( compentry ) then
	  mfield = mainfield_i
	  efield = expfield_i
	else
	  mfield = mainfield
	  efield = expfield
	endif
	

*  if the STO key has been pressed, then we need to store the screen
*  value in a memory register, if the RCL key has been pressed, then
*  we need to retrieve a value from a memory register.

	if( (memopt .gt. 1 .or. rclopt .gt. 1) .and. ch .eq. '.' ) then
	  if( (memopt .lt. 4 .and. rclopt .lt. 4) .and. mempoint .eq. 0 ) then
		mempoint = 1
		if( memopt .gt. 1 ) then
		  memopt = memopt - 1
		else
		  rclopt = rclopt - 1
		endif
	  else
	  	memopt = 0
	  	rclopt = 0
	  	call beep()
	  endif
	  return
	endif

	if( memopt .eq. 2 .or. (memopt .eq. 3 .and. memact .gt. 0) ) then
	  imr = ichar(ch) - 47
	  if(imr .lt. 1 .or. imr .gt. 10) return
	  if( mempoint .gt. 0 ) imr = imr + 10
	  cmpval  = dcmplx(memstore(imr,1),memstore(imr,2))
  	  cmpval2 = dcmplx( screenval, screenval_i )
	  if(memopt .eq. 3) then
		if( memact .eq. PLUSACT ) then
		  cmpval = cmpval + cmpval2
		elseif( memact .eq. MINUSACT ) then
		  cmpval = cmpval - cmpval2
		elseif( memact .eq. MULTACT ) then
		  cmpval = cmpval * cmpval2
		elseif( memact .eq. DIVACT .or. memact .eq. MODACT ) then
		  if( screenval .eq. 0. .and. screenval_i .eq. 0.) then
		    cmpval = 1.0d150
		  elseif( memact .eq. DIVACT ) then
		    cmpval = cmpval / cmpval2
		  else
		    if (compmode) then
		      cmpval = 1.0d150
		      errstate = 2
		    else
		      cmpval = dmod(memstore(imr,1),screenval)
		    endif
		  endif
		endif
		if(splitcmp(1) .ne. 0.) then
		    if( abs(log10(abs(splitcmp(1)))) .gt. 99 ) then
		      call beep()
		      return
		    endif
		endif
		if(splitcmp(2) .ne. 0.) then
		    if( abs(log10(abs(splitcmp(2)))) .gt. 99 ) then
		      call beep()
		      return
		    endif
		endif
	  else
		cmpval = cmpval2
	  endif

*	  flash the letter 'M' for 300 milliseconds to let the user know
*	  that a value was successfully stored in a memory register (use napms)

	  memopt = 0
	  memstore(imr,1) = splitcmp(1)
	  memstore(imr,2) = splitcmp(2)

	  retval = displayval( screenval, screenval_i )
	  retval = mvwaddstr(calcwin, 1, 28, 'M' )
	  retval = wnoutrefresh( calcwin )
	  retval = move(0,0)
	  retval = refresh()
	  if( playback .le. 0 ) then
		retval = napms( 300 )
	  endif
	  retval = mvwaddstr(calcwin, 1, 28, ' ' )
	  retval = wnoutrefresh( calcwin )
	  return
	endif

	if( rclopt .eq. 2 .or. rclopt .eq. 3 .and. memact .gt. 0 ) then
	  imr = ichar(ch) - 47
	  if(imr .lt. 1 .or. imr .gt. 10) return
	  if( mempoint .gt. 0 ) imr = imr + 10
	  call liftstack
  	  cmpval   = dcmplx( screenval, screenval_i )
	  cmpval2  = dcmplx(memstore(imr,1),memstore(imr,2))
	  if(rclopt .eq. 3) then
		if( memact .eq. PLUSACT ) then
		  cmpval = cmpval + cmpval2
		elseif( memact .eq. MINUSACT ) then
		  cmpval = cmpval - cmpval2
		elseif( memact .eq. MULTACT ) then
		  cmpval = cmpval * cmpval2
		elseif( memact .eq. DIVACT .or. memact .eq. MODACT ) then
		  if( memstore(imr,1) .eq. 0. .and.
&		      memstore(imr,2) .eq. 0. ) then
		    cmpval = 1.0d150
		  elseif( memact .eq. DIVACT ) then
		    cmpval = cmpval / cmpval2
		  else
		    if(compmode) then
		      cmpval = 1.0d150
		      errstate = 2
		    else
		      cmpval = dmod(screenval,memstore(imr,1))
		    endif
		  endif
		endif
	  else
		cmpval = cmpval2
	  endif

	  rclopt = 0
	  retval = displayval( splitcmp(1), splitcmp(2) )
	  if( rpnmode .and. action .and. retval .eq. -1 ) then
	    do i = 1, MAXREGS-1
		  regval(i,1) = regval(i+1,1)
		  regval(i,2) = regval(i+1,2)
	    end do
	    regval(MAXREGS,1) = lastpop
	    regval(MAXREGS,2) = lastpop_i
	  elseif( rpnmode ) then
	    action = .true.
	  endif
	  return
	endif

*  if the backspace key is pressed before a number has been entered (via
*  another operation like add, subtract, equal, etc.), then undo what has
*  been entered to this point until the number is back to zero.

	if( ch .eq. '-' ) then
	  if( .not. numinit ) then

		if( eepress ) then
			call loadfield( efield, tmpstr )
		else
			call loadfield( mfield, tmpstr )
			tmpstr = stripcommas( tmpstr )
		endif
		is = firstchr( tmpstr )
		if( compentry ) then
		  call getval( screenval_i )
		else
		  call getval( screenval )
		endif
		if(is .eq. 0) return
		ie = lastchr( tmpstr )

		if( eepress ) then
			if( tmpstr(ie-1:ie) .eq. '00' ) then
			  eepress = .false.
			  tmpstr = ' '
			else
			  tmpstr(ie:ie) = tmpstr(ie-1:ie-1)
			  tmpstr(ie-1:ie-1) = '0'
			endif
			retval = wjustify( efield, tmpstr, 2, .FALSE., .TRUE.)
		else

			if( tmpstr(ie:ie) .eq. '.' ) then
				dpoint = .false.
				ie = ie - 1
			endif
			do ic = ie, is+1, -1
				tmpstr(ic:ic) = tmpstr(ic-1:ic-1)
			end do
			tmpstr(is:is) = ' '
			if( is .eq. ie ) then
			  numpress = .false.
			  tmpstr = '0.'
			endif
			if( commas ) then
				tmpstr = addcommas( tmpstr )
			endif
			retval = wjustify( mfield, tmpstr, 2, .FALSE., .TRUE.)
		endif

	  endif

*  save the current display value

	  if( compentry ) then
	    call getval( screenval_i )
	  else
	    call getval( screenval )
	  endif
	  return

	endif

*	if the calculator has completed an operation, then new numeric
*	entry clears the display field and starts with a value of 0.0.
*		(set appropriate flags)

	if( numinit ) then

		call liftstack
		
		retval = wjustify( mainfield, '0.', 2, .FALSE., .TRUE.)
		retval = wjustify( expfield, '      ', 2, .FALSE., .TRUE.)

		retval = wjustify( mainfield_i,'      ', 2, .FALSE., .TRUE.)
		retval = wjustify( expfield_i, '      ', 2, .FALSE., .TRUE.)

		screenval   = 0.
		screenval_i = 0.
		if( rpnmode ) then
		  action = .true.
		else
		  action = .false.
		endif
		dpoint = .false.
		eepress = .false.
		numpress = .false.

		numinit = .false.

	endif

	if( ch .eq. ';' ) then

		retval = wjustify( mainfield_i, '0.', 2, .FALSE., .TRUE.)
		retval = wjustify( expfield_i, '      ', 2, .FALSE., .TRUE.)
		dpoint = .false.
		eepress = .false.
		numpress = .false.

		compentry = .true.
		return

	endif

*  pressing the decimal point key changes how other numerals are processed

	if( ch .eq. '.' ) then
		if( .not. dpoint ) then
			dpoint = .true.
			if( rpnmode ) then
			  call loadfield( mfield, tmpstr )
			  ic = index(tmpstr,'.')
			  if( ic .eq. 0 ) then
			    ie = lastchr(tmpstr)
			    tmpstr2 = tmpstr(:ie)//'.'
			    tmpstr = tmpstr2
			    retval = wjustify( mfield, tmpstr, 2, .FALSE., .TRUE.)
			  endif
			endif
		endif
		
		return
	endif

*	if the EE key was pressed, then work with the exponent field

	if( eepress ) then
		call loadfield( efield, tmpstr )
	else
		call loadfield( mfield, tmpstr )
		tmpstr = stripcommas( tmpstr )
	endif

*	find the part of the temparary string actually holding something
*	besides blanks.

	is = firstchr( tmpstr )
	if( compentry ) then
	  call getval( screenval_i )
	else
	  call getval( screenval )
	endif
	if(is .eq. 0) return
	ie = lastchr( tmpstr )

*	change the sign of the number being entered ( or the exponent if
*	that is what is being worked with)

	if( ch .eq. '\' ) then
		if( eepress ) then
			ic = index(tmpstr,'+')
			if( ic .lt. 1) then
			  ic = index(tmpstr,'-')
			  if(ic .lt. 1) then
			    if( compentry ) then
			      call getval( screenval_i )
			    else
			      call getval( screenval )
			    endif
			    return
			  endif
			endif
			if( tmpstr(ic:ic) .eq. '-' ) then
				tmpstr(ic:ic) = '+'
			else
				tmpstr(ic:ic) = '-'
			endif
		else
			if( tmpstr(is:is) .eq. '-' ) then
				tmpstr(is:is) = ' '
			else
				is = is - 1
				tmpstr(is:is) = '-'
			endif
		endif
	else


*		in this block we should just be dealing with the numeral 0-9.

		if( eepress ) then

*		   allow maximum exponont of +/- 99.  just roll two character
*		   position until user settles on a two digit number

			tmpstr(ie-1:ie-1) = tmpstr(ie:ie)
			tmpstr(ie:ie) = ch
		else

*			limit length of the number

			if( (ie-is) .eq. 12) then
				if( tmpstr(is:is) .ne. '-' ) return
			elseif( (ie-is) .ge. 13 ) then
				return
			endif

			if( dpoint ) then
				tmpstr2 = tmpstr(is:ie)//ch
				tmpstr = tmpstr2
				numpress = .true.
			else
			  if( rpnmode ) then
			    ic = ie
			  else
			    ic = index( tmpstr, '.' ) - 1
			  endif
			  if( .not. numpress ) then
			    if(ch .ne. '0') then
			      if( rpnmode ) then
			        tmpstr(ic-1:ic) = ' '//ch
			      else
			    	tmpstr(ic:ic) = ch
			      endif
			      numpress = .true.
			    endif
			  else
			    if( rpnmode ) then
			      tmpstr2 = tmpstr(is:ic)//ch
			      tmpstr = tmpstr2
			    else
			      tmpstr2 = tmpstr(is:ic)//ch//tmpstr(ic+1:ie)
			      tmpstr = tmpstr2
			    endif
			  endif
			endif


		endif

	endif

	if( eepress ) then
		retval = wjustify( efield, tmpstr, 2, .FALSE., .TRUE.)
	else
		if( commas ) then
			tmpstr = addcommas( tmpstr )
		endif
		retval = wjustify( mfield, tmpstr, 2, .FALSE., .TRUE.)
	endif

	if( compentry ) then
	  call getval( screenval_i )
	else
	  call getval( screenval )
	endif

	return
	end
