
************************************************************

	subroutine popact( value, value_i, ACTTYPE )

*	operate on the displayed value and the value stored in register 1
*	using the action associated with register 1, then store the resulting
*	number in register one.
	
	implicit none
	
	real*8 value, value_i
	integer*4 ACTTYPE

	include 'calcstat.fh'
	include 'register.fh'

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	equivalence ( cmpval, splitcmp(1) )

	cmpval  = dcmplx( value, value_i )
	cmpval2 = dcmplx( regval(1,1), regval(1,2) )

* assume multiply/divides have higher precenedence than adds/subtracts
*   (sort of like implicit parenthesis) and that exponentials (y^X) have the
*   highest precedence of all.

	if( regact(1) .eq. POWRACT ) then
	  if( compmode ) then
	    if( value*log10(abs(regval(1,1))) .lt. 105 .and.
&	        value_i*log10(abs(regval(1,2))) .lt. 105 .and.
&	        value*log10(abs(regval(1,2))) .lt. 105 .and.
&	        value_i*log10(abs(regval(1,1))) .lt. 105 ) then
	      cmpval = cmpval2**cmpval
	    else
	      cmpval = 1.0d150
	    endif
	  else
	    if(regval(1,1) .gt. 0. .or. (regval(1,1) .lt. 0. .and.
&	    			value .eq. int(value)) ) then
	      if( value * log10(abs(regval(1,1))) .lt. 100 ) then
	        cmpval = regval(1,1)**value
	      else
	        cmpval = 1.0d150
	      endif
	    elseif( regval(1,1) .lt. 0. ) then
	      cmpval = 1.0d150
	    elseif( value .gt. 0. ) then
	      cmpval = 0.
	    else
	      cmpval = 1.0d150
	    endif
	  endif

	  if( ACTTYPE .eq. POWRACT ) then
	    go to 100
	  else
	    regval(1,1) = regvalmd(1,1)
	    regvalmd(1,1) = regvalpw(1,1)
	    regval(1,2) = regvalmd(1,2)
	    regvalmd(1,2) = regvalpw(1,2)
	    regact(1) = regactmd(1)
	    regactmd(1) = regactpw(1)
	  endif

	elseif( ACTTYPE .eq. POWRACT ) then

	  regvalpw(1,1) = regvalmd(1,1)
	  regvalmd(1,1) = regval(1,1)
	  regvalpw(1,2) = regvalmd(1,2)
	  regvalmd(1,2) = regval(1,2)
	  regactpw(1) = regactmd(1)
	  regactmd(1) = regact(1)
	  go to 100

	endif

	if( ACTTYPE .eq. PLUSACT .or. ACTTYPE .eq. MINUSACT .or.
&	  ACTTYPE .eq. EQUALACT .or. ACTTYPE .eq. CLOSEACT .or.
&	  (regact(1) .ne. PLUSACT .and. regact(1) .ne. MINUSACT)) then

		if( regact(1) .eq. PLUSACT ) then
		  cmpval = cmpval2 + cmpval
		elseif( regact(1) .eq. MINUSACT ) then
		  cmpval = cmpval2 - cmpval
		elseif( regact(1) .eq. MULTACT ) then
		  cmpval = cmpval2 * cmpval
		elseif( regact(1) .eq. DIVACT .or. regact(1) .eq. MODACT ) then
		  if( value .eq. 0. .and. value_i .eq. 0. ) then
		    cmpval = 1.0d150
		  elseif( regact(1) .eq. DIVACT ) then
		    cmpval = cmpval2 / cmpval
		  else
		    if( compmode ) then
		      cmpval = 1.0d150
		      errstate = 2
		    else
		      cmpval = dmod( regval(1,1), value )
		    endif
		  endif
		endif

	else
		regvalmd(1,1) = regval(1,1)
		regvalmd(1,2) = regval(1,2)
		regactmd(1) = regact(1)
	endif  

	if( ACTTYPE .eq. PLUSACT .or. ACTTYPE .eq. MINUSACT .or.
&	    ACTTYPE .eq. EQUALACT .or. ACTTYPE .eq. CLOSEACT) then

		if( regactmd(1) .ne. 0) then
		  if( regactmd(1) .eq. PLUSACT) then
		    cmpval = cmpval2 + cmpval
		  elseif( regactmd(1) .eq. MINUSACT ) then
		    cmpval = cmpval2 - cmpval
		  endif
		  regactmd(1) = 0
		endif

	endif

  100	value       = splitcmp(1)
  	value_i     = splitcmp(2)
  	regval(1,1) = value
  	regval(1,2) = value_i

	return
	end
