***********************************************************************
* wrs (8/13/92)
* -- SCREENIMAGE --
*  a routine to save any contents of a region the physical screen to a
*  window so that they can later be restored.

* (10/12/94) -- added the clearok call

*  ideal for popping up menus

*  return NULL on error.
*  if successful, return a integer window pointer if win is NULL
*			return non-NULL otherwise

*  this routine may not work well if typeahead in enabled (Curses default)
*    because the screen may only get partially written before it is saved.
*    To disable typeahead the main program should make
*    the call  "call typeahead(-1)"
*****************************************************

	integer*4 function screenimage( shadow, win )

	implicit none

	include '../../curses.fh'

	integer*4  shadow, win, retval, begy, begx, ydim, xdim

***depending on the situation, one might want to do an update at this point**
*	retval = doupdate()
**********************

	screenimage = NULL

*	"shadow" is the copy that will be made of window "win"
*	if "shadow" is NULL, then the window hasn't ever been created
*	up to this point.  Duplicate the contents of "win" in "shadow"

	if( shadow .eq. NULL) then

*		get the orientation and dimensions of the window "win"

		call getbegyx( win, begy, begx )
		call getmaxyx( win, ydim, xdim )

		retval = newwin( ydim, xdim, begy, begx )
		if( retval .ne. NULL ) then
			if( overwrite( curscr, retval ) .eq. ERR ) then
				call delwin( retval )
				return
			endif
			screenimage = retval
		else
			return
		endif
	else

*	if "shadow" has already been used once before, then just overwrite it
*	with the current contents of the screen in that area.

*	"curscr" is a window pointer to the physical screen image.

		if( overwrite(curscr, shadow) .eq. ERR ) then
			call delwin( shadow )
			shadow = NULL
			return
		else
			screenimage = shadow
		endif
	endif

	if( screenimage .ne. NULL ) then
		call clearok( screenimage, .FALSE. )
	endif
	return

	end

