* wrs
* calculations for the different functions chosen from the 
* statistics functions menu
*  (split out of "curscalc.f" to reduce the size of that source file)

	subroutine statfunc(ichosen, xstat, x2stat, ystat, y2stat,
&				xystat, nstat, seed)

	implicit none

	integer ichosen, seed
	real*8  xstat, x2stat, ystat, y2stat, xystat, nstat

	include 'calclate.fh'
	include 'calcstat.fh'
	include 'register.fh'

	integer displayval, imx, i, retval, statstat
	real*4  random

	real*8  mtmp, ntmp

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	equivalence ( cmpval, splitcmp(1) )

	lastx   = screenval
	lastx_i = screenval_i
	statstat = 1

	if( ichosen .eq. 1 ) then

* Accumulate Statistics
		statstat = -1
		xstat  = xstat  + screenval
		x2stat = x2stat + screenval*screenval
		ystat  = ystat  + regval(1,1)
		y2stat = y2stat + regval(1,1)**2.0
		xystat = xystat + screenval*regval(1,1)

		nstat  = nstat + 1.
		tmpval = nstat

	elseif( ichosen .eq. 2 ) then

* Unaccumulate Statistics (error correction)

		statstat = -1
		if(nstat .eq. 0.) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  xstat  = xstat  - screenval
		  x2stat = x2stat - screenval*screenval
		  ystat  = ystat  - regval(1,1)
		  y2stat = y2stat - regval(1,1)**2.0
		  xystat = xystat - screenval*regval(1,1)

		  nstat  = nstat - 1.
		  tmpval = nstat
		endif

	elseif( ichosen .eq. 3 ) then

* Display the Mean of the accumulated x values, store the y mean in y

		call liftstack
		if( nstat .eq. 0. ) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  action = .true.
		  call liftstack
		  tmpval = xstat / nstat
		  regval(1,1) = ystat / nstat
		  regval(1,2) = 0.
		endif

	elseif( ichosen .eq. 4 ) then

* Standard Deviation: x in display, y in y

		call liftstack
		if( nstat .le. 1. ) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  action = .true.
		  call liftstack
		  tmpval = ( (nstat*x2stat - xstat**2.0) /
&		  		( nstat*(nstat-1.) ) ) ** 0.5
		  regval(1,1) = ( (nstat*y2stat - ystat**2.0) /
&		  		( nstat*(nstat-1.) ) ) ** 0.5
		  regval(1,2) = 0.
		endif

	elseif( ichosen .eq. 5 ) then

* Linear Regression: y intercept in x, slope in y

		call liftstack
		mtmp = nstat*x2stat - xstat**2.0
		if( nstat .le. 1. .or. mtmp .eq. 0. ) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  action = .true.
		  call liftstack
		  tmpval = (mtmp*ystat -
&		           (nstat*xystat - xstat*ystat)*xstat)/(nstat*mtmp)
		  regval(1,1) = (nstat*xystat -	xstat*ystat)/mtmp
		  regval(1,2) = 0.
		endif

	elseif( ichosen .eq. 6 ) then

* Linear estimate

		mtmp = nstat*x2stat - xstat**2.0
		if( nstat .le. 1. .or. mtmp .eq. 0. ) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  tmpval = ( mtmp*ystat + ( nstat*xystat - xstat*ystat ) *
&		  	   ( nstat*screenval - xstat ) ) / ( nstat * mtmp )
		endif

	elseif( ichosen .eq. 7 ) then

* Correlation Coefficient (r)

		call liftstack
		mtmp = nstat*x2stat - xstat**2.0
		ntmp = nstat*y2stat - ystat**2.0
		if( nstat .le. 1. .or. mtmp*ntmp .le. 0. ) then
		  tmpval = 1.0d150
		  errstate = 3
		else
		  tmpval = ( nstat*xystat - xstat*ystat ) /
&		  		( mtmp * ntmp ) ** 0.5
		endif

	elseif( ichosen .eq. 8 ) then

* Display number of data points entered

		call liftstack
		tmpval = nstat

	elseif( ichosen .eq. 9 ) then

* Display summation of x-values

		call liftstack
		tmpval = xstat

	elseif( ichosen .eq. 10 ) then

* Display summation of squares of x-values

		call liftstack
		tmpval = x2stat

	elseif( ichosen .eq. 11 ) then

* Display summation of y-values

		call liftstack
		tmpval = ystat

	elseif( ichosen .eq. 12 ) then

* Display summation of squares of y-values

		call liftstack
		tmpval = y2stat

	elseif( ichosen .eq. 13 ) then

* Display summation of products of x- and y-values

		call liftstack
		tmpval = xystat

	elseif( ichosen .eq. 14 .or. ichosen .eq. 15) then

* Display permutations of y,x or Combinations of y,x

		if( screenval .lt. 0. .or. screenval .gt. 69
&		    .or. screenval .ne. nint(screenval) .or.
&		    regval(1,1) .lt. 0. .or. regval(1,1) .gt. 69
&		    .or. regval(1,1) .ne. nint(regval(1,1)) .or.
&		    regval(1,1) .lt. screenval ) then
		   tmpval = 1.0d150
		   errstate = 3
		else
		   imx = nint( regval(1,1) )
		   ntmp = 1.0
		   do i = 1, imx
		      ntmp = ntmp * i
		   end do
		   imx = nint( screenval )
		   mtmp = 1.0
		   do i = 1, imx
		      mtmp = mtmp * i
		   end do
		   imx = nint( regval(1,1) - screenval )
		   tmpval = 1.0
		   do i = 1, imx
		      tmpval = tmpval * i
		   end do

		   if( ichosen .eq. 14 ) then
		     tmpval = ntmp / tmpval
		   else
		     tmpval = ntmp / ( mtmp * tmpval )
		   endif

		endif

	elseif( ichosen .eq. 16 ) then

*	random #
		if( numinit ) then
		  call liftstack
		endif
		tmpval = random(seed)

	elseif( ichosen .eq. 17 ) then

*	Clear statistic storage registers

		statstat = 0

		tmpval = 0.
		xstat  = 0.
		x2stat = 0.
		ystat  = 0.
		y2stat = 0.
		xystat = 0.
		nstat  = 0.

	endif

	retval = displayval( tmpval, dble(0.) )
	if( rpnmode ) then
		if( retval .eq. -1 .or. statstat .eq. -1 ) then
			action = .false.
		elseif( statstat .gt. 0 ) then
		  	action = .true.
		endif
	else
	  	action = .false.
	endif
	numinit = .true.

	return
	end
