* wrs
* calculations for the different conversions chosen from the unit conversions
* menu
*  (split out of "curscalc.f" to reduce the size of that source file)

	subroutine unitconv(ichosen, convdir)

	implicit none

	integer ichosen, convdir

	include 'calclate.fh'
	include 'calcstat.fh'
	include 'register.fh'

	integer displayval, imx, i, retval
	real*4  random

	complex*16 cmpval, cmpval2
	real*8     splitcmp(2)
	equivalence ( cmpval, splitcmp(1) )

	lastx   = screenval
	lastx_i = screenval_i
	cmpval = dcmplx( screenval, screenval_i )

	if( ichosen .eq. 1 ) then

*  polar/rectangular coordinates conversion

	    if( compmode ) then
	      if( screenval .eq. 0. .and. screenval_i .eq. 0. ) then
	        cmpval = 0.
	      elseif( convdir .eq. 1 ) then
	        splitcmp(1) = sqrt( screenval**2. + screenval_i**2. )
	        splitcmp(2) = acos( screenval/splitcmp(1) )
	        if( radflag .eq. 1 ) then
	          splitcmp(2) = splitcmp(2) * 90./asin(1.0d0)
	        elseif( radflag .eq. 3 ) then
	          splitcmp(2) = splitcmp(2) * 100./asin(1.0d0)
	        endif
	      else
	        if( radflag .eq. 1 ) then
	          splitcmp(2) = splitcmp(2) * asin(1.0d0)/90.
	        elseif( radflag .eq. 3 ) then
	          splitcmp(2) = splitcmp(2) * asin(1.0d0)/100.
	        endif
	        splitcmp(1) = screenval * cos( splitcmp(2) )
	        splitcmp(2) = screenval * sin( splitcmp(2) )
	      endif
	    else
	      if( screenval .eq. 0. .and. regval(1,1) .eq. 0. ) then
	        tmpval = 0.
	      elseif( convdir .eq. 1 ) then
	        tmpval = sqrt( screenval**2. + regval(1,1)**2. )
	        regval(1,1) = acos( screenval/tmpval )
	        if( radflag .eq. 1 ) then
	          regval(1,1) = regval(1,1) * 90./asin(1.0d0)
	        elseif( radflag .eq. 3 ) then
	          regval(1,1) = regval(1,1) * 100./asin(1.0d0)
	        endif
	      else
	        if( radflag .eq. 1 ) then
	          regval(1,1) = regval(1,1) * asin(1.0d0)/90.
	        elseif( radflag .eq. 3 ) then
	          regval(1,1) = regval(1,1) * asin(1.0d0)/100.
	        endif
	        tmpval = screenval * cos( regval(1,1) )
	        regval(1,1) = screenval * sin( regval(1,1) )
	      endif
	      cmpval = dcmplx( tmpval, dble(0.) )
	    endif

	elseif( ichosen .eq. 2 ) then

*  Degrees to Radians conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval * asin(1.0D0)/90.0d0
	    else
	      cmpval = cmpval * 90.0d0/asin(1.0D0)
	    endif

	elseif( ichosen .eq. 3 ) then

*  Fahrenheit/Celcius Temperature conversion

	    if( convdir .eq. 1 ) then
	      cmpval = (cmpval - 32.)/1.8
	    else
	      cmpval = 1.8*cmpval + 32.
	    endif

	elseif( ichosen .eq. 4 ) then

*  mile/foot length conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*5280.
	    else
	      cmpval = cmpval/5280.
	    endif

	elseif( ichosen .eq. 5 ) then

*  foot/meter length conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*0.3048
	    else
	      cmpval = cmpval/0.3048
	    endif

	elseif( ichosen .eq. 6 ) then

*  inch/centimeter length conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*2.540
	    else
	      cmpval = cmpval/2.540
	    endif

	elseif( ichosen .eq. 7 ) then

*  foot^3/gallon volume conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*7.4805
	    else
	      cmpval = cmpval/7.4805
	    endif

	elseif( ichosen .eq. 8 ) then

*  gallon/liter volume conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval/0.2642
	    else
	      cmpval = cmpval*0.2642
	    endif

	elseif( ichosen .eq. 9 ) then

*  mile/hr - meter/s velocity conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*4.4704d-1
	    else
	      cmpval = cmpval/4.4704d-1
	    endif

	elseif( ichosen .eq. 10 ) then

*  lbm/kilogram mass conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*0.45359237d0
	    else
	      cmpval = cmpval/0.45359237d0
	    endif

	elseif( ichosen .eq. 11 ) then

*  lbf/Newton force conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*4.44822
	    else
	      cmpval = cmpval/4.44822
	    endif

	elseif( ichosen .eq. 12 ) then

*  inHg/atmosphere pressure conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*0.0334
	    else
	      cmpval = cmpval/0.0334
	    endif

	elseif( ichosen .eq. 13 ) then

*  atmosphere - lbf/in^2 pressure conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*14.69595
	    else
	      cmpval = cmpval/14.69595
	    endif

	elseif( ichosen .eq. 14 ) then

*  lbf/in^2 - N/m^2 pressure conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*6894.76
	    else
	      cmpval = cmpval/6894.76
	    endif

	elseif( ichosen .eq. 15 ) then

*  Btu/ft-lbf energy conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*778.16
	    else
	      cmpval = cmpval/778.16
	    endif

	elseif( ichosen .eq. 16 ) then

*  ft-lbf/Joule energy conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*1.3558
	    else
	      cmpval = cmpval/1.3558
	    endif

	elseif( ichosen .eq. 17 ) then

*  Joule/calorie energy conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval/4.1854
	    else
	      cmpval = cmpval*4.1854
	    endif

	elseif( ichosen .eq. 18 ) then

*  horsepower/Watt power conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval*745.7
	    else
	      cmpval = cmpval/745.7
	    endif

	elseif( ichosen .eq. 19 ) then

*  Watt - ft-lb/s power conversion

	    if( convdir .eq. 1 ) then
	      cmpval = cmpval/1.35582
	    else
	      cmpval = cmpval*1.35582
	    endif

	endif

	retval = displayval( splitcmp(1), splitcmp(2) )
	if( rpnmode ) then
		if( retval .eq. -1 ) then
			action = .false.
	  	else
		  	action = .true.
		endif
	else
	  	action = .false.
	endif
	numinit = .true.

	return
	end
