
*****************************
* wrs (8/11/92) -- a fortran curses utility routine
* -- WJUSTIFY --
**************************************************************************
*  justify and print a string on a window line (left, right, center)
*						( 1, 2, 3)

	integer function wjustify( win, str, opt, scrollopt, stripled )


*	the window cursor is on a particular line already, this routine
*	doesn't care what row position the cursor has, but instead calculates
*	the necessary x offset to print the string left, right, or center
*	justified on the string.

*	the routine strips trailing blanks (leading blanks are stripped
*	if the argument "stripled" is .TRUE.)

	implicit none

	include '../../curses.fh'

	integer win, opt
	logical scrollopt, stripled
	character*(*) str

	integer ypos, xwidth, xtmp, ytmp, xpos, retval

	integer firstchr, lastchr, ll, is

*	find out where the cursor was last at in the window (row,column)
*	and the total line width that is available.

	retval = getyx( win, ypos, xtmp)
	retval = getmaxyx( win, ytmp, xwidth )

	wjustify = ERR

*	clear the window line

	retval = wmove(win, ypos, 0)
	retval = wclrtoeol(win)

*	uses "lastchr" to find last non-blank character position of str.

*	if "stripled" is .TRUE., then use "firstchr" to find the first
*	non-blank character in the string, if it's .FALSE., then print
*	leading blanks.

	if( stripled ) then
		is = firstchr( str )
	else
		is = 1
	endif
	ll = lastchr( str )
	if(ll .lt. is) then
		return
	endif

*	choose position to begin writing string depending on the
*	justification option that was chosen.

	if( opt .eq. 1) then
	  xpos = 0
	elseif( opt .eq. 2) then
	  xpos = xwidth - (ll - is + 1 )
	elseif( opt .eq. 3) then
	  xpos = (xwidth - (ll - is + 1) )/2
	else
	  return
	endif

*	if the user passed scrollopt as .TRUE., then send a newline when
*	the line is added (wprintw as opposed to waddstr)
*		this will only work if scrollok has been set to true
*		for window win.

	if(wmove(win, ypos, xpos) .ne. ERR) then
	  if( scrollopt ) then
		  if( winsstr( win, str(is:ll) ) .ne. ERR) then
		    call mvwaddch( win, ypos, xwidth-1, KEY_NEWLN )
		    wjustify = OK
		  endif
	  else
		  if( winsstr( win, str(is:ll) ) .ne. ERR) then
		    wjustify = OK
		  endif
	  endif
	endif
	  
	return
	end
