
*****************************************************************
* wrs (9/7/94)

*  isint

*  see if a string is a valid integer number (based on the isreal routine)
*
*    input string is passed as argument, routine returns logical true
*    or false.
*
	logical function isint( str )

	implicit none

	character*(*) str
	character*1   ch

	logical  digit, lsign

	integer ll, ic, blank

******************************

	isint = .false.

	ll = len(str)

	if(ll .lt. 1) return

	blank   = 0
	digit   = .false.
	lsign   = .false.

*       any "returns" in the loop signify an error, the value of "isint" will
*	then be the -1 set above

	do ic = 1,ll

	   ch = str(ic:ic)

	   if(ch .ne. ' ' .and. ch .ne. char(0) ) then

*            allow blanks before and after number, but no blanks between
*            other valid characters

	     if(blank .eq. 2) return
	     blank = 1

*	     can have one sign value before the number

	     if(ch .eq. '+' .or. ch .eq. '-') then

	       if(.not. lsign) then
	         lsign = .true.
	       else
	         return
	       endif

*	     valid characters

	     elseif( ichar(ch) .ge. 48 .and. ichar(ch) .le. 57 ) then

	         digit = .true.

*	     found some illegal character

	     else
	       return
	     endif

	   elseif(blank .eq. 1) then
	       blank = 2
	   endif

	end do

*	a string with all blanks is equal to zero

	if(blank .ne. 0) then
	  if(.not. digit) return
	endif

********************************
*  combine the values that have been calculated

	isint = .true.

********************************

	return

	end
