
*****************************************************************
* wrs (9/7/94)

*  isreal

*  see if a string is a valid real number (based on the ch2dble routine)
*
*    input string is passed as argument, routine returns logical true
*    or false.
*
	logical function isreal( str )

	implicit none

	character*(*) str
	character*1   ch

	logical  digit, expon, point, lsign, lpsign, exdigit

	integer ll, ic, blank

******************************

	isreal = .false.

	ll = len(str)

	if(ll .lt. 1) return

	blank   = 0
	digit   = .false.
	exdigit = .false.
	expon   = .false.
	point   = .false.
	lsign   = .false.
	lpsign  = .false.

*       any "returns" in the loop signify an error, the value of "isreal" will
*	then be the -1 set above

	do ic = 1,ll

	   ch = str(ic:ic)

	   if(ch .ne. ' ' .and. ch .ne. char(0) ) then

*            allow blanks before and after number, but no blanks between
*            other valid characters

	     if(blank .eq. 2) return
	     blank = 1

*	     can have one sign value before the number and one before the
*	     exponent (optional)

	     if(ch .eq. '+' .or. ch .eq. '-') then

	       if(.not. lsign) then
	         if(digit .or. point) then
	           return
	         endif
	         lsign = .true.
	       elseif(expon .and. (.not. lpsign)) then
	         if(exdigit) then
	           return
	         endif
	         lpsign = .true.
	       else
	         return
	       endif

*	     "e" or "d" signifies an exponent is following

	     elseif(ch .eq. 'E' .or. ch .eq. 'e' .or. ch .eq. 'D' .or.
     .              ch .eq. 'd' ) then

	       if(digit .and. (.not. expon)) then
	         expon = .true.
*	         a positive sign value was implicit if we found an
*	         exponent
	         lsign = .true.
	       else
	         return
	       endif

*	     a decimal point is only allowed as part of the number, not
*	     the exponent.

	     elseif(ch .eq. '.') then    

	       if( point .or. expon) then
	         return
	       else
	         point = .true.
	       endif

*	     modify the number or the exponent value considering whether or
*            not a decimal point has been found

	     elseif( ichar(ch) .ge. 48 .and. ichar(ch) .le. 57 ) then

	       if(.not. expon) then
	         digit = .true.
	       else
	         exdigit = .true.
	       endif

*	     found some illegal character

	     else
	       return
	     endif

	   elseif(blank .eq. 1) then
	       blank = 2
	   endif

	end do

*	a string with all blanks is equal to zero

	if(blank .ne. 0) then
	  if(.not. digit) return
	  if(expon .and. (.not. exdigit)) return
	endif

********************************
*  combine the values that have been calculated

	isreal = .true.

********************************

	return

	end
