* wrs (1993)
******************************************************************

* generate a popup menu using menu items passed

*   - returns the number of the menu item that was selected.

	integer function popupmenu( menuitem, MAXITEMS, ystart, xstart,
&	   menupair, hlitpair, lastitem, title, actch, escape )

* menuitem (string)
*  an array of text strings that will make up the contents of a top
*  down menu.  each string will be a menu item.

* MAXITEMS (integer)
*  the total number of items in the menu (less than or equal to the
*  total number of elements in the menuitem array)

* ystart (integer)
*  the row position of the top left corner of the menu window (where 0
*  is the first row on the screen)

* xstart (integer)
*  the column position of the top left corner of the menu window ( where 0
*  is the first column on the screen)

* menupair (integer)
*  the text attribute that you want to use for the menu, assumed to
*  be a color pair combination passed as COLOR_PAIR(n), but could be
*  an attribute like A_BOLD, or A_REVERSE, etc.  On non-color terminals,
*  the routine will use A_NORMAL.

* hlitpair (integer)
*  the text attribute that you want to use for the highlighted menu
*  item, assumed be a color pair combination passed as COLOR_PAIR(n),
*  but could be an attribute like A_BOLD, or A_REVERSE, etc.  Should
*  be a contrast to the attribute used for menupair.   On non-color
*  terminals, the routine will use A_REVERSE.

* lastitem (integer)
*  has two purposes;  it is used to determine which item of the
*  menu is highlighted when the menu is first opened.  When a menu
*  item is chosen, then lastitem will contain the number of the item
*  chosen.  It will also contain the number of the last item highlighted
*  when the menu is left by pressing the actch key.

* title (character string)
*  menu title

* actch (integer)
*  this contains the integer value of a character that will cause proper
*  exit of the menu without actually selecting an item.  popform will
*  return the value -5 to let the calling program know that actch was
*  pressed.  The value is integer so that valid characters can include
*  curses function key codes as well as regular characters passed with
*  the ICHAR function (e.g., ICHAR('a'), KEY_F(1), CTRL('a'), etc.)

* escape (logical)
*  if this value is .false., then the menu can only be left if a menu item
*  is selected, if the <backspace> key is pressed, or if the "actch"
*  key is pressed.  If escape is .TRUE., then any other character 
*  that is typed will cause the menu to close with a return value of
*  -1000 times the integer value of the character.

	implicit none

	include '../../curses.fh'

	integer MAXITEMS, ystart, xstart
	character*(*) menuitem(MAXITEMS)
	character*(*) title
	integer*4   actch
	logical escape

	integer borderwin, popupwin

*	shadow holds the contents of the screen that will be hidden
*	when another window is displayed

	integer shadow, line1shad

	character*4 tmpstr
	character*256 blanks

	integer retval, onitem, width, i, ll, attr, offattr,
&		onattr, ch, menupair, hlitpair, lastitem, is, ie, titwidth
	integer firstchr, lastchr, xpos

	popupmenu = ERR
	onitem = 1
	if(lastitem .gt. 0 .and. lastitem .le. MAXITEMS ) then
	  onitem = lastitem
	endif

	width = 0
	do i = 1, MAXITEMS
	   ll = lastchr( menuitem(i) )
	   width = max( width, ll )
	end do

	is = firstchr( title )
	ie = lastchr( title )
	titwidth = ie - is + 1
	width = max( width, (titwidth+4) )

	width = min( width, COLS - xstart - 2 )
	titwidth = min( titwidth, width-4 )

	if( width .le. 0 ) return

	shadow = newwin( MAXITEMS+2, width+2, ystart, xstart )
	if( shadow .eq. NULL ) return
	if( overwrite( curscr, shadow ) .eq. ERR ) go to 500

	line1shad = newwin( 1, COLS, 0, 0 )
	if( line1shad .eq. NULL ) go to 500
	if( overwrite( curscr, line1shad ) .eq. ERR ) go to 500

	borderwin = newwin( MAXITEMS+2, width+2, ystart, xstart )
	if( borderwin .eq. NULL ) go to 500
	retval = box( borderwin, ACS_VLINE, ACS_HLINE )
	xpos = ( width - titwidth )/2 + 1
	retval = mvwaddch( borderwin, 0, xpos-1, ACS_RTEE )
	retval = mvwaddstr( borderwin, 0, xpos, title(is:is+titwidth-1) )
	retval = mvwaddch( borderwin, 0, xpos+titwidth, ACS_LTEE )

	popupwin = newwin( MAXITEMS, width, ystart+1, xstart+1 )
	if( popupwin .eq. NULL ) go to 500

	retval = leaveok(popupwin, .TRUE.)
	retval = keypad(popupwin, .TRUE.)

	if ( has_colors() .and. COLOR_PAIRS .gt. 0 ) then
		retval = wbkgd( borderwin, menupair )
		retval = wbkgd( popupwin, menupair )
		offattr = A_NORMAL
		onattr = hlitpair
	else
		retval = wbkgd( borderwin, A_NORMAL )
		retval = wbkgd( popupwin, A_NORMAL )
		offattr = A_NORMAL
		onattr = A_REVERSE
	endif

	blanks = ' '
	retval = wattron( popupwin, offattr )
	retval = wattroff( popupwin, offattr )
	do i = 1, MAXITEMS
	   if( i .eq. onitem ) then
	     attr = onattr
	   else
	     attr = offattr
	   endif
	   retval = wattron( popupwin, attr )
	   retval = wmove( popupwin, i-1, 0 )
	   retval = waddnstr( popupwin, blanks, width )
	   retval = wmove( popupwin, i-1, 0 )
	   retval = waddnstr( popupwin, menuitem(i), width )
	   retval = wattroff( popupwin, attr )
	end do

*	now display the popupmenu window on the physical screen.

	retval = wnoutrefresh( borderwin )
	retval = wnoutrefresh( popupwin )
	retval = move(0,0)
	retval = refresh()

	i = onitem
	do while (.true.)

		ch = wgetch(popupwin)

		if(ch .eq. KEY_RIGHT .or. ch .eq. KEY_LEFT .or.
&			ch .eq. KEY_UP .or. ch .eq. KEY_DOWN ) then

			retval = wattron( popupwin, offattr )
			retval = wmove( popupwin, i-1, 0 )
			retval = waddnstr( popupwin, blanks, width )
			retval = wmove( popupwin, i-1, 0 )
			retval = waddnstr( popupwin, menuitem(i), width )
			retval = wattroff( popupwin, offattr )

			if(ch .eq. KEY_DOWN .or. ch .eq. KEY_RIGHT) then
				i = i + 1
			else
				i = i - 1
			endif
			if( i .gt. MAXITEMS ) i = 1
			if( i .lt. 1 ) i = MAXITEMS

			retval = wattron( popupwin, onattr )
			retval = wmove( popupwin, i-1, 0 )
			retval = waddnstr( popupwin, blanks, width )
			retval = wmove( popupwin, i-1, 0 )
			retval = waddnstr( popupwin, menuitem(i), width )
			retval = wattroff( popupwin, onattr )

		elseif( ch .eq. KEY_NEWLN .or. ch .eq. KEY_CR .or.
&			ch .eq. ichar(' ') .or. ch .eq. NULL ) then

			popupmenu = i
			lastitem = i
			go to 500

		elseif( ch .eq. KEY_BACKSPACE ) then

			popupmenu = 0
			lastitem = i
			go to 500

		elseif ( ch .eq. CTRL('L') ) then

			retval = touchwin( curscr )
			retval = wrefresh( curscr )

		elseif ( ch .eq. actch ) then

			popupmenu = -5
			lastitem = i
			go to 500

		elseif ( escape ) then

			popupmenu = -1000*ch
			lastitem  = i
			go to 500

		else

			retval = beep()

		endif

		retval = wnoutrefresh( popupwin )
		retval = move(0,0)
		retval = refresh()

	end do

  500	if( shadow .ne. NULL ) then
  		retval = touchwin(shadow)
		retval = wrefresh( shadow )
	endif
	if( line1shad .ne. NULL ) then
		retval = touchwin( line1shad )
		retval = wrefresh( line1shad )
	endif
	retval = flushinp()

  	if( shadow .ne. NULL ) then
  		retval = delwin( shadow )
  	endif
  	if( line1shad .ne. NULL ) then
  		retval = delwin( line1shad )
  	endif
     	if( borderwin .ne. NULL ) then
  		retval = delwin( borderwin )
  	endif
     	if( popupwin .ne. NULL ) then
  		retval = delwin( popupwin )
  	endif

  	return

  	end
