* WRS
*  firework -- a FORTRAN (F-curses) version of a C (curses) program.

	implicit none

	include '../../curses.fh'

       integer*4 start,end,row,diff,flag,direction,seed,retval

       integer*4 myrefresh

       real*4 random

       retval = initscr()

       retval = raw()
       retval = nodelay( stdscr, .TRUE. )
       retval = noecho()
       retval = nonl()

       if (has_colors()) retval = start_color()

       seed = 1535

       do while( sgetch() .eq. ERR )

  100           start = random(seed) * (COLS-3)
                end   = random(seed) * (COLS-3)
                start = max( start, 2 )
                end = max( end, 2 )

                if( start .gt. end ) then
                  direction = -1
                else
                  direction = 1
                endif
                diff = abs(start-end)
                if ( diff .lt. 2 .or. diff .ge. LINES-2) go to 100

                retval = attrset(A_NORMAL)

                do row = 0, diff-1

                   if( direction .lt. 0 ) then
                     retval = mvaddstr(LINES - row,
     .                        start + (row * direction), '\')
                   else
                     retval = mvaddstr(LINES - row,
     .                        start + (row * direction), '/')
                   endif

                   if (flag .gt. 0) then
                           retval = myrefresh()
                           retval = clear()
                           flag = 0
                   else
                           flag = 1
                   endif

               end do

               if (flag .gt. 0) then
                        retval = myrefresh()
                        flag = 0
               else
                        flag = 1
               endif

               call explode( LINES-row, start+(diff*direction), seed )
               retval = clear()
               retval = myrefresh()

       end do

       call endwin()
       end


********************************************************

      subroutine explode(row,col,seed)

      include '../../curses.fh'

      integer*4 row, col, seed, get_color

       retval = clear()
       retval = mvaddstr(row,col,'-')
       retval = myrefresh()

       if( has_colors() ) then
         retval = init_pair(1,get_color(seed),COLOR_BLACK)
         retval = attrset(COLOR_PAIR(1))
       endif
       retval = mvaddstr(row-1,col-1,' - ')
       retval = mvaddstr(row,col-1,'-+-')
       retval = mvaddstr(row+1,col-1,' - ')
       retval = myrefresh()

       if( has_colors() ) then
         retval = init_pair(2,get_color(seed),COLOR_BLACK)
         retval = attrset(COLOR_PAIR(2))
       endif
       retval = mvaddstr(row-2,col-2,' --- ')
       retval = mvaddstr(row-1,col-2,'-+++-')
       retval = mvaddstr(row,  col-2,'-+#+-')
       retval = mvaddstr(row+1,col-2,'-+++-')
       retval = mvaddstr(row+2,col-2,' --- ')
       retval = myrefresh()

       if( has_colors() ) then
         retval = init_pair(3,get_color(seed),COLOR_BLACK)
         retval = attrset(COLOR_PAIR(3))
       endif
       retval = mvaddstr(row-2,col-2,' +++ ')
       retval = mvaddstr(row-1,col-2,'++#++')
       retval = mvaddstr(row,  col-2,'+# #+')
       retval = mvaddstr(row+1,col-2,'++#++')
       retval = mvaddstr(row+2,col-2,' +++ ')
       retval = myrefresh()

       if( has_colors() ) then
         retval = init_pair(4,get_color(seed),COLOR_BLACK)
         retval = attrset(COLOR_PAIR(4))
       endif
       retval = mvaddstr(row-2,col-2,'  #  ')
       retval = mvaddstr(row-1,col-2,'## ##')
       retval = mvaddstr(row,  col-2,'#   #')
       retval = mvaddstr(row+1,col-2,'## ##')
       retval = mvaddstr(row+2,col-2,'  #  ')
       retval = myrefresh()

       if( has_colors() ) then
         retval = init_pair(5,get_color(seed),COLOR_BLACK)
         retval = attrset(COLOR_PAIR(5))
       endif
       retval = mvaddstr(row-2,col-2,' # # ')
       retval = mvaddstr(row-1,col-2,'#   #')
       retval = mvaddstr(row,  col-2,'     ')
       retval = mvaddstr(row+1,col-2,'#   #')
       retval = mvaddstr(row+2,col-2,' # # ')
       retval = myrefresh()

       return
       end

********************************************************

      integer*4 function myrefresh()

      include '../../curses.fh'

       retval = napms(100)
       retval = move(LINES-1,COLS-1)
       retval = refresh()

       return
       end

*********************************************************

      integer*4 function get_color(seed)

      include '../../curses.fh'

      integer*4 attr, seed, itmp
      real*4 random

       itmp = random(seed)*7 + 1

       if ( has_colors() ) then
         if (itmp .eq. 1) then
            attr = COLOR_RED
         elseif (itmp .eq. 2) then
            attr = COLOR_GREEN
         elseif (itmp .eq. 3) then
            attr = COLOR_YELLOW
         elseif (itmp .eq. 4) then
            attr = COLOR_BLUE
         elseif (itmp .eq. 5) then
            attr = COLOR_MAGENTA
         elseif (itmp .eq. 6) then
            attr = COLOR_CYAN
         else
            attr = COLOR_WHITE
         endif
       else
         attr = A_NORMAL
       endif

       itmp = random(seed)*2 + 1

       if( itmp .gt. 1)  attr = B_OR( attr, A_BOLD )

       get_color = attr
       return
       end

*****************************************************************

*  a generic overflow psuedo random number generator
*	(requires a seed number to be passed from/to the calling program)

	real*4 function random( seed )
	
	implicit none
	
	integer*4 seed, iy

	iy = seed * 65539
	if ( iy .lt. 0 ) iy = ( iy + 2147483647 ) + 1

	random = iy * 0.4656613e-09

	if(random .lt. 0.0001) then
	  random = 0.000001
	else if( random .ge. 1.0) then
	  random = 0.999999
	endif

	seed = iy

	return
	end

