* Copyright (C) 1993 Wade R. Schauer
* All Rights Reserved

************************************************************************

* since C and Fortran handle strings a bit differently, the C longname 
* equivalent in Fortran required both this intermediate Fortran routine
* and the C stub longtmp ( in termattrs.c )

	character*(*) function longname()

	implicit none

	call longtmp( longname, len(longname) )

	return

	end

************************************************************************

* since C and Fortran handle strings a bit differently, the C termname 
* equivalent in Fortran required both this intermediate Fortran routine
* and the C stub termtmp ( in termattrs.c )

	character*(*) function termname()

	implicit none

	call termtmp( termname, len(termname) )

	return

	end

************************************************************************

* since C and Fortran handle strings a bit differently, the C unctrl 
* equivalent in Fortran required both this intermediate Fortran routine
* and the C stub unctrltmp ( in util.c )

	character*(*) function unctrl( c )

	implicit none

	integer*4 c

	call unctrltmp( unctrl, len(unctrl), c )

	return

	end

************************************************************************

* since C and Fortran handle strings a bit differently, the C keyname 
* equivalent in Fortran required both this intermediate Fortran routine
* and the C stub keynametmp ( in util.c )

	character*(*) function keyname( c )

	implicit none

	integer*4 c

	call keynametmp( keyname, len(keyname), c )

	return

	end


**********************************************************************
*  some Fortran compilers pass a pointer for the length of a string,
*  others path the length as a value.
*
*  to make Fortran curses compiler non-specific, calculate the length
*  of a string and pass that as a pointer explicitly for string writing
*  and reading functions.  (did the same thing for the above routines
*  as well, but they had other reasons for being here).

****************************************************************
	integer*4 function waddstr( wnum, str )

	implicit none

	integer*4     wnum
	character*(*) str

	integer*4  twaddstr

	waddstr = twaddstr( wnum, str, len(str) )

	return
	end

****************************************************************
	integer*4 function addstr( str )

	implicit none

	character*(*) str

	integer*4  taddstr

	addstr = taddstr( str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvwaddstr( wnum, y, x, str )

	implicit none

	integer*4     wnum, y, x
	character*(*) str

	integer*4  tmvwaddstr

	mvwaddstr = tmvwaddstr( wnum, y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvaddstr( y, x, str )

	implicit none

	integer*4     y, x
	character*(*) str

	integer*4  tmvaddstr

	mvaddstr = tmvaddstr( y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvwaddnstr( wnum, y, x, str, n )

	implicit none

	integer*4     wnum, y, x, n
	character*(*) str

	integer*4  tmvwaddnstr

	mvwaddnstr = tmvwaddnstr( wnum, y, x, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function mvaddnstr( y, x, str, n )

	implicit none

	integer*4     y, x, n
	character*(*) str

	integer*4  tmvaddnstr

	mvaddnstr = tmvaddnstr( y, x, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function waddnstr( wnum, str, n )

	implicit none

	integer*4     wnum, n
	character*(*) str

	integer*4  twaddnstr

	waddnstr = twaddnstr( wnum, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function addnstr( str, n )

	implicit none

	integer*4     n
	character*(*) str

	integer*4  taddnstr

	addnstr = taddnstr( str, len(str), n )

	return
	end

****************************************************************
	integer*4 function wprintw( wnum, str )

	implicit none

	integer*4     wnum
	character*(*) str

	integer*4  twprintw

	wprintw = twprintw( wnum, str, len(str) )

	return
	end

****************************************************************
	integer*4 function printw( str )

	implicit none

	character*(*) str

	integer*4  tprintw

	printw = tprintw( str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvwprintw( wnum, y, x, str )

	implicit none

	integer*4     wnum, y, x
	character*(*) str

	integer*4  tmvwprintw

	mvwprintw = tmvwprintw( wnum, y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvprintw( y, x, str )

	implicit none

	integer*4     y, x
	character*(*) str

	integer*4  tmvprintw

	mvprintw = tmvprintw( y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function wgetstr( wnum, str )

	implicit none

	integer*4     wnum
	character*(*) str

	integer*4  twgetstr

	str = ' '
	wgetstr = twgetstr( wnum, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function getstr( str )

	implicit none

	character*(*) str

	integer*4  tgetstr

	str = ' '
	getstr = tgetstr( str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvwgetstr( wnum, y, x, str )

	implicit none

	integer*4     wnum, y, x
	character*(*) str

	integer*4  tmvwgetstr

	str = ' '
	mvwgetstr = tmvwgetstr( wnum, y, x, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvgetstr( y, x, str )

	implicit none

	integer*4     y, x
	character*(*) str

	integer*4  tmvgetstr

	str = ' '
	mvgetstr = tmvgetstr( y, x, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function wgetnstr( wnum, str, n )

	implicit none

	integer*4     wnum, n
	character*(*) str

	integer*4  twgetnstr

	str = ' '
	wgetnstr = twgetnstr( wnum, str, len(str), n )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function winsstr( wnum, str )

	implicit none

	integer*4     wnum
	character*(*) str

	integer*4  twinsstr

	winsstr = twinsstr( wnum, str, len(str) )

	return
	end

****************************************************************
	integer*4 function insstr( str )

	implicit none

	character*(*) str

	integer*4  tinsstr

	insstr = tinsstr( str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvwinsstr( wnum, y, x, str )

	implicit none

	integer*4     wnum, y, x
	character*(*) str

	integer*4  tmvwinsstr

	mvwinsstr = tmvwinsstr( wnum, y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvinsstr( y, x, str )

	implicit none

	integer*4     y, x
	character*(*) str

	integer*4  tmvinsstr

	mvinsstr = tmvinsstr( y, x, str, len(str) )

	return
	end

****************************************************************
	integer*4 function mvwinsnstr( wnum, y, x, str, n )

	implicit none

	integer*4     wnum, y, x, n
	character*(*) str

	integer*4  tmvwinsnstr

	mvwinsnstr = tmvwinsnstr( wnum, y, x, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function mvinsnstr( y, x, str, n )

	implicit none

	integer*4     y, x, n
	character*(*) str

	integer*4  tmvinsnstr

	mvinsnstr = tmvinsnstr( y, x, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function winsnstr( wnum, str, n )

	implicit none

	integer*4     wnum, n
	character*(*) str

	integer*4  twinsnstr

	winsnstr = twinsnstr( wnum, str, len(str), n )

	return
	end

****************************************************************
	integer*4 function insnstr( str, n )

	implicit none

	integer*4     n
	character*(*) str

	integer*4  tinsnstr

	insnstr = tinsnstr( str, len(str), n )

	return
	end

****************************************************************
	integer*4 function winstr( wnum, str )

	implicit none

	integer*4     wnum
	character*(*) str

	integer*4  twinstr

	str = ' '
	winstr = twinstr( wnum, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function instr( str )

	implicit none

	character*(*) str

	integer*4  tinstr

	str = ' '
	instr = tinstr( str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvwinstr( wnum, y, x, str )

	implicit none

	integer*4     wnum, y, x
	character*(*) str

	integer*4  tmvwinstr

	str = ' '
	mvwinstr = tmvwinstr( wnum, y, x, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvinstr( y, x, str )

	implicit none

	integer*4     y, x
	character*(*) str

	integer*4  tmvinstr

	str = ' '
	mvinstr = tmvinstr( y, x, str, len(str) )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvwinnstr( wnum, y, x, str, n )

	implicit none

	integer*4     wnum, y, x, n
	character*(*) str

	integer*4  tmvwinnstr

	str = ' '
	mvwinnstr = tmvwinnstr( wnum, y, x, str, len(str), n )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function mvinnstr( y, x, str, n )

	implicit none

	integer*4     y, x, n
	character*(*) str

	integer*4  tmvinnstr

	str = ' '
	mvinnstr = tmvinnstr( y, x, str, len(str), n )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function winnstr( wnum, str, n )

	implicit none

	integer*4     wnum, n
	character*(*) str

	integer*4  twinnstr

	str = ' '
	winnstr = twinnstr( wnum, str, len(str), n )
	call clearnull( str )

	return
	end

****************************************************************
	integer*4 function innstr( str, n )

	implicit none

	integer*4     n
	character*(*) str

	integer*4  tinnstr

	str = ' '
	innstr = tinnstr( str, len(str), n )
	call clearnull( str )

	return
	end

**************************************************************************

* convert nulls into blanks in a Fortran character string

	subroutine clearnull( str )

	implicit none

	character*(*) str

	integer tmplen, i
	
	tmplen = len(str)

* treat NULLS as blank

	do i = 1, tmplen
		if ( str(i:i) .eq. char(0)) then
			str(i:i) = ' '
		endif
	end do

	return
	end

****************************************************************

	integer*4 function rawprint( str )

	implicit none

	character*(*) str

	integer*4  trawprint

	rawprint = trawprint( str, len(str) )

	return
	end
