* Copyright (C) 1993 Wade R. Schauer
* All Rights Reserved

************************************************************************

* wrs (7/16/92) -- this routine starts F-curses and initializes the majority
*			of the curses pre-defined variables

	function initscr()

	implicit none

	include 'curses.fh'

	integer*4 inittmp, cursparm
	character*14 termstr

	initscr = inittmp( .TRUE., .FALSE.)

*  DON'T CHANGE THE FOLLOWING SECTION OF CODE
**************************************************************************

*  if the call to curses was successful, then the return value will be the
*  pointer to "stdscr," otherwise the return value will be NULL

	stdscr   = initscr

	call setcursparm()

	curs_errno 	= cursparm( 1)
	LINES 		= cursparm( 2)
	COLS 		= cursparm( 3)
	COLOR_BLACK 	= cursparm( 4)
	COLOR_RED 	= cursparm( 5)
	COLOR_GREEN 	= cursparm( 6)
	COLOR_YELLOW 	= cursparm( 7)
	COLOR_BLUE 	= cursparm( 8)
	COLOR_MAGENTA 	= cursparm( 9)
	COLOR_CYAN 	= cursparm(10)
	COLOR_WHITE 	= cursparm(11)
	TABSIZE 	= cursparm(12)
	ERR 		= cursparm(13)
	OK 		= cursparm(14)
	NULL 		= cursparm(15)
	A_STANDOUT 	= cursparm(16)
	A_UNDERLINE 	= cursparm(17)
	A_REVERSE 	= cursparm(18)
	A_BLINK 	= cursparm(19)
	A_DIM 		= cursparm(20)
	A_BOLD 		= cursparm(21)
	A_INVIS 	= cursparm(22)
	A_PROTECT 	= cursparm(23)
	A_NORMAL 	= cursparm(24)
	A_ATTRIBUTES 	= cursparm(25)
	A_CHARTEXT 	= cursparm(26)
	A_COLOR 	= cursparm(27)
	KEY_NEWLN 	= cursparm(28)
	KEY_CR 		= cursparm(29)
	KEY_FF 		= cursparm(30)
	KEY_TAB 	= cursparm(31)
	KEY_MIN 	= cursparm(32)
	KEY_BREAK 	= cursparm(33)
	KEY_DOWN 	= cursparm(34)
	KEY_UP 		= cursparm(35)
	KEY_LEFT 	= cursparm(36)
	KEY_RIGHT 	= cursparm(37)
	KEY_HOME 	= cursparm(38)
	KEY_BACKSPACE 	= cursparm(39)
	KEY_F0 		= cursparm(40)
	KEY_DL 		= cursparm(41)
	KEY_IL 		= cursparm(42)
	KEY_DC 		= cursparm(43)
	KEY_IC 		= cursparm(44)
	KEY_EIC 	= cursparm(45)
	KEY_CLEAR 	= cursparm(46)
	KEY_EOS 	= cursparm(47)
	KEY_EOL 	= cursparm(48)
	KEY_SF 		= cursparm(49)
	KEY_SR 		= cursparm(50)
	KEY_NPAGE 	= cursparm(51)
	KEY_PPAGE 	= cursparm(52)
	KEY_STAB 	= cursparm(53)
	KEY_CTAB 	= cursparm(54)
	KEY_CATAB 	= cursparm(55)
	KEY_ENTER 	= cursparm(56)
	KEY_SRESET 	= cursparm(57)
	KEY_RESET 	= cursparm(58)
	KEY_PRINT 	= cursparm(59)
	KEY_LL 		= cursparm(60)
	KEY_A1 		= cursparm(61)
	KEY_A3 		= cursparm(62)
	KEY_B2 		= cursparm(63)
	KEY_C1 		= cursparm(64)
	KEY_C3 		= cursparm(65)
	KEY_BTAB 	= cursparm(66)
	KEY_BEG 	= cursparm(67)
	KEY_CANCEL 	= cursparm(68)
	KEY_CLOSE 	= cursparm(69)
	KEY_COMMAND 	= cursparm(70)
	KEY_COPY 	= cursparm(71)
	KEY_CREATE 	= cursparm(72)
	KEY_END 	= cursparm(73)
	KEY_EXIT 	= cursparm(74)
	KEY_FIND 	= cursparm(75)
	KEY_HELP 	= cursparm(76)
	KEY_MARK 	= cursparm(77)
	KEY_MESSAGE 	= cursparm(78)
	KEY_MOVE 	= cursparm(79)
	KEY_NEXT 	= cursparm(80)
	KEY_OPEN 	= cursparm(81)
	KEY_OPTIONS 	= cursparm(82)
	KEY_PREVIOUS 	= cursparm(83)
	KEY_REDO 	= cursparm(84)
	KEY_REFERENCE 	= cursparm(85)
	KEY_REFRESH 	= cursparm(86)
	KEY_REPLACE 	= cursparm(87)
	KEY_RESTART 	= cursparm(88)
	KEY_RESUME 	= cursparm(89)
	KEY_SAVE 	= cursparm(90)
	KEY_SBEG 	= cursparm(91)
	KEY_SCANCEL 	= cursparm(92)
	KEY_SCOMMAND 	= cursparm(93)
	KEY_SCOPY 	= cursparm(94)
	KEY_SCREATE 	= cursparm(95)
	KEY_SDC 	= cursparm(96)
	KEY_SDL 	= cursparm(97)
	KEY_SELECT 	= cursparm(98)
	KEY_SEND 	= cursparm(99)
	KEY_SEOL 	= cursparm(100)
	KEY_SEXIT 	= cursparm(101)
	KEY_SFIND 	= cursparm(102)
	KEY_SHELP 	= cursparm(103)
	KEY_SHOME 	= cursparm(104)
	KEY_SIC 	= cursparm(105)
	KEY_SLEFT 	= cursparm(106)
	KEY_SMESSAGE 	= cursparm(107)
	KEY_SMOVE 	= cursparm(108)
	KEY_SNEXT 	= cursparm(109)
	KEY_SOPTIONS 	= cursparm(110)
	KEY_SPREVIOUS 	= cursparm(111)
	KEY_SPRINT 	= cursparm(112)
	KEY_SREDO 	= cursparm(113)
	KEY_SREPLACE 	= cursparm(114)
	KEY_SRIGHT 	= cursparm(115)
	KEY_SRSUME 	= cursparm(116)
	KEY_SSAVE 	= cursparm(117)
	KEY_SSUSPEND 	= cursparm(118)
	KEY_SUNDO 	= cursparm(119)
	KEY_SUSPEND 	= cursparm(120)
	KEY_UNDO 	= cursparm(121)
	NULL 		= cursparm(122)
	KEY_MAX 	= cursparm(123)
	curscr 		= cursparm(124)

* map to vt100 alternate character set.

	ACS_ULCORNER 	= cursparm(125)
	ACS_LLCORNER 	= cursparm(126)
	ACS_URCORNER 	= cursparm(127)
	ACS_LRCORNER 	= cursparm(128)
	ACS_RTEE     	= cursparm(129)
	ACS_LTEE     	= cursparm(130)
	ACS_BTEE     	= cursparm(131)
	ACS_TTEE     	= cursparm(132)
	ACS_HLINE    	= cursparm(133)
	ACS_VLINE    	= cursparm(134)
	ACS_PLUS     	= cursparm(135)

* Teletype 5410v1 symbols

	ACS_S1		= cursparm(136)
	ACS_S9		= cursparm(137)
	ACS_DIAMOND	= cursparm(138)
	ACS_CKBOARD	= cursparm(139)
	ACS_DEGREE	= cursparm(140)
	ACS_PLMINUS	= cursparm(141)
	ACS_BULLET	= cursparm(142)

	ACS_LARROW	= cursparm(143)
	ACS_RARROW	= cursparm(144)
	ACS_DARROW	= cursparm(145)
	ACS_UARROW	= cursparm(146)
	ACS_BOARD	= cursparm(147)
	ACS_LANTERN	= cursparm(148)
	ACS_BLOCK	= cursparm(149)

	A_ALTCHARSET 	= cursparm(150)

*	until start_colors() is called, set the following two to zero

	COLORS = 0
	COLOR_PAIRS = 0

***********************************************************************
***********************************************************************

*  DEPENDING ON YOUR TERMINAL TYPE, YOU MAY WANT TO ADD SOME TERMINAL
*  SPECIFIC CODE BELOW

* double-line graphics characters hard coded to a specific terminal type.
* only use if you aren't worried about terminal independence

*  you can add your own, the only one so far is AT386/AT386-M

*    get the name of the terminal

	termstr = termname()


*	if it is an AT386 and AT386-M

	if( termstr(:5) .eq. 'at386' .or. termstr(:5) .eq. 'AT386' .or.
&		termstr(:5) .eq. '386AT' .or. termstr(:5) .eq. '386at'
&		.or.
&	    termstr(:7) .eq. 'at386-m' .or. termstr(:7) .eq. 'AT386-M'
&		.or. termstr(:7) .eq. '386AT-M' .or. termstr(:7) .eq.
&		'386at-m') then

		ACS_DULCORNER	= B_OR( A_ALTCHARSET, ICHAR('I') )
		ACS_DLLCORNER	= B_OR( A_ALTCHARSET, ICHAR('H') )
		ACS_DURCORNER	= B_OR( A_ALTCHARSET, ICHAR(';') )
		ACS_DLRCORNER	= B_OR( A_ALTCHARSET, ICHAR('<') )
		ACS_DRTEE	= B_OR( A_ALTCHARSET, ICHAR('9') )
		ACS_DLTEE	= B_OR( A_ALTCHARSET, ICHAR('L') )
		ACS_DBTEE	= B_OR( A_ALTCHARSET, ICHAR('J') )
		ACS_DTTEE	= B_OR( A_ALTCHARSET, ICHAR('K') )
		ACS_DHLINE	= B_OR( A_ALTCHARSET, ICHAR('M') )
		ACS_DVLINE	= B_OR( A_ALTCHARSET, ICHAR(':') )
		ACS_DPLUS	= B_OR( A_ALTCHARSET, ICHAR('N') )

*		WRS(10/93)
*		i've seen too many instances where the terminfo AT386
*		terminfo file doesn't have the correct alternate
*		character set mappings, so I'll put them here explicitly

		ACS_ULCORNER 	= B_OR( A_ALTCHARSET, ICHAR('Z') )
		ACS_LLCORNER 	= B_OR( A_ALTCHARSET, ICHAR('@') )
		ACS_URCORNER 	= B_OR( A_ALTCHARSET, ICHAR('?') )
		ACS_LRCORNER 	= B_OR( A_ALTCHARSET, ICHAR('Y') )
		ACS_RTEE     	= B_OR( A_ALTCHARSET, ICHAR('4') )
		ACS_LTEE     	= B_OR( A_ALTCHARSET, ICHAR('C') )
		ACS_BTEE     	= B_OR( A_ALTCHARSET, ICHAR('A') )
		ACS_TTEE     	= B_OR( A_ALTCHARSET, ICHAR('B') )
		ACS_HLINE    	= B_OR( A_ALTCHARSET, ICHAR('D') )
		ACS_VLINE    	= B_OR( A_ALTCHARSET, ICHAR('3') )
		ACS_PLUS     	= B_OR( A_ALTCHARSET, ICHAR('E') )
* skipped S1, S9 (scan lines)
* skipped diamond
		ACS_CKBOARD	= B_OR( A_ALTCHARSET, ICHAR('1') )
		ACS_DEGREE	= B_OR( A_ALTCHARSET, ICHAR('x') )
		ACS_PLMINUS	= B_OR( A_ALTCHARSET, ICHAR('q') )
		ACS_BULLET	= B_OR( A_ALTCHARSET, ICHAR('~') )
		ACS_LARROW	= B_OR( A_ALTCHARSET, ICHAR('.') )
		ACS_RARROW	= B_OR( A_ALTCHARSET, ICHAR('/') )
* skipped down/up arrows
		ACS_BOARD	= B_OR( A_ALTCHARSET, ICHAR('2') )
		ACS_LANTERN	= B_OR( A_ALTCHARSET, ICHAR('h') )
		ACS_BLOCK	= B_OR( A_ALTCHARSET, ICHAR('[') )

*               enable underline mode on AT386 terminals if not already there
		call rawprint( char(KEY_ESC)//'[38m' )

*	if it is a DOS or OS/2 terminal

	elseif( termstr(:3) .eq. 'CGA' .or. termstr(:3) .eq. 'MDA' .or.
&		termstr(:8) .eq. 'EGAColor' .or. termstr(:7) .eq.
&	 	'EGAMono' .or.
&	    termstr(:8) .eq. 'VGAColor' .or. termstr(:7) .eq. 'VGAMono'
&		.or. termstr(:9) .eq. 'MCGAColor' .or. termstr(:8) .eq.
&		'MCGAMono' .or. termstr(:6) .eq. 'Genius' ) then

		ACS_DULCORNER	= 201
		ACS_DLLCORNER	= 200
		ACS_DURCORNER	= 187
		ACS_DLRCORNER	= 188
		ACS_DRTEE	= 185
		ACS_DLTEE	= 204
		ACS_DBTEE	= 202
		ACS_DTTEE	= 203
		ACS_DHLINE	= 205
		ACS_DVLINE	= 186
		ACS_DPLUS	= 206

	else

*          else default to single-line graphics

		ACS_DULCORNER	= ACS_ULCORNER
		ACS_DLLCORNER	= ACS_LLCORNER
		ACS_DURCORNER	= ACS_URCORNER
		ACS_DLRCORNER	= ACS_LRCORNER
		ACS_DRTEE	= ACS_RTEE
		ACS_DLTEE	= ACS_LTEE
		ACS_DBTEE	= ACS_BTEE
		ACS_DTTEE	= ACS_TTEE
		ACS_DHLINE	= ACS_HLINE
		ACS_DVLINE	= ACS_VLINE
		ACS_DPLUS	= ACS_PLUS

	endif

	return
	end

*********************************************************************
*  DON'T CHANGE THE FOLLOWING TWO FUNCTIONS
*********************************************************************
*********************************************************************

*	mapping of the curses "start_color" function, which initializes the two
*	curses variables COLORS and COLOR_PAIRS and enables a terminals
*	color capabilities
	
	function start_color()
	
	implicit none	

	include 'curses.fh'

	integer*4 start_colc, colorlim, colorpset
	character*14 termstr

	start_color = start_colc()

	COLORS = colorlim()
	COLOR_PAIRS = colorpset()

*	On some implementations of 386/486 UNIX, the AT386 terminal driver
*	behaves poorly if color mode is started when the underline capability
*	is still enabled, so disable it.  The following escape sequence
*	shoulde be harmless on terminals that don't have the problem...

	termstr = termname()
	if( termstr(:5) .eq. 'at386' .or. termstr(:5) .eq. 'AT386' .or.
&		termstr(:5) .eq. '386AT' .or. termstr(:5) .eq. '386at') then
		call rawprint( char(KEY_ESC)//'[39m' )
	endif

	RETURN
	END

*********************************************************************

*  return the integer value of a control-key combination
	
	integer*4 function CTRL( ch )
	
	implicit none	

	integer*4 ch, B_AND

	CTRL = B_AND( ch, o'37')

	RETURN
	END

****************************************************************

	integer*4 function COLOR_PAIR( pair )

	implicit none

	integer*4  clr_pair
	integer*4  pair

	COLOR_PAIR = clr_pair( pair )

	return
	end

****************************************************************

	integer*4 function PAIR_NUMBER( attrs )

	implicit none

	integer*4  pair_nmbr
	integer*4  attrs

	PAIR_NUMBER = pair_nmbr( attrs )

	return
	end
